; SDAS compatible header file MS51_8K.asm 20210823.
; For Nuvoton MS51_8K series.

;.ifndef MS51_8K_ASM
;.define MS51_8K_ASM

P0 .EQU 0x80
   IC3_P00      .EQU 0x80+0 ;Input Capture 3
   PWM0_CH3_P00 .EQU 0x80+0 ;Pulse Width Modulator 0 Channel 3
   T1           .EQU 0x80+0 ;Timer 1
   MOSI         .EQU 0x80+0 ;Master Out Slave In
   ADC_CH7      .EQU 0x80+1 ;Analog Digital Converter Channel 7
   ACH7         .EQU 0x80+1 ;ADC Channel 7
   ADC7         .EQU 0x80+1 ;AtoD Channel 7
   AIN7         .EQU 0x80+1 ;Analog Input 7
   CLKO         .EQU 0x80+1 ;Clock Out
   IC4          .EQU 0x80+1 ;Input Capture 4
   MISO         .EQU 0x80+1 ;Master In Slave Out
   PWM0_CH4     .EQU 0x80+1 ;Pulse Width Modulator 0 Channel 4
   IC0          .EQU 0x80+2 ;Input Capture 0
   ICE_CLK      .EQU 0x80+2 ;In Circuit Emulator Clock
   PWM0_CH0     .EQU 0x80+2 ;Pulse Width Modulator 0 Channel 0
   RXD_1        .EQU 0x80+2 ;Receive Data 1
   TXD_1_P02    .EQU 0x80+2 ;Transmit Data 1
   ADC_CH6      .EQU 0x80+3 ;Analog Digital Converter Channel 6
   ACH6         .EQU 0x80+3 ;ADC Channel 6
   ADC6         .EQU 0x80+3 ;AtoD Channel 6
   AIN6         .EQU 0x80+3 ;Analog Input 6
   IC5          .EQU 0x80+3 ;Input Capture 5
   PWM0_CH5     .EQU 0x80+3 ;Pulse Width Modulator 0 Channel 5
   SCL          .EQU 0x80+3 ;Serial Clock
   STADC_P03    .EQU 0x80+3 ;Start Analog to Digital Conversion
   ADC_CH5      .EQU 0x80+4 ;Analog Digital Converter Channel 5
   ACH5         .EQU 0x80+4 ;ADC Channel 5
   ADC5         .EQU 0x80+4 ;AtoD Channel 5
   AIN5         .EQU 0x80+4 ;Analog Input 5
   IC3_P04      .EQU 0x80+4 ;Input Capture 3
   PWM0_BRAKE   .EQU 0x80+4 ;Pulse Width Modulator 0 Brake
   PWM0_CH3_P04 .EQU 0x80+4 ;Pulse Width Modulator 0 Channel 3
   STADC        .EQU 0x80+4 ;Start Analog to Digital Conversion
   SDA          .EQU 0x80+4 ;Serial Data
   ADC_CH4      .EQU 0x80+5 ;Analog Digital Converter Channel 4
   ACH4         .EQU 0x80+5 ;ADC Channel 4
   ADC4         .EQU 0x80+5 ;AtoD Channel 4
   AIN4         .EQU 0x80+5 ;Analog Input 4
   IC6          .EQU 0x80+5 ;Input Capture 6
   PWM0_CH2_P05 .EQU 0x80+5 ;Pulse Width Modulator 0 Channel 2
   SS           .EQU 0x80+5 ;Slave Select
   T0           .EQU 0x80+5 ;Timer 0
   ADC_CH3      .EQU 0x80+6 ;Analog Digital Converter Channel 3
   ACH3         .EQU 0x80+6 ;ADC Channel 3
   ADC3         .EQU 0x80+6 ;AtoD Channel 3
   AIN3         .EQU 0x80+6 ;Analog Input 3
   RXD_P06      .EQU 0x80+6 ;Receive Data
   TXD          .EQU 0x80+6 ;Transmit Data
   P00 .EQU 0x80+0 ;Port 0 Bit 0
   P01 .EQU 0x80+1 ;Port 0 Bit 1
   P02 .EQU 0x80+2 ;Port 0 Bit 2
   P03 .EQU 0x80+3 ;Port 0 Bit 3
   P04 .EQU 0x80+4 ;Port 0 Bit 4
   P05 .EQU 0x80+5 ;Port 0 Bit 5
   P06 .EQU 0x80+6 ;Port 0 Bit 6
   P0_0 .EQU 0x80+0 ;Port 0 Bit 0
   P0_1 .EQU 0x80+1 ;Port 0 Bit 1
   P0_2 .EQU 0x80+2 ;Port 0 Bit 2
   P0_3 .EQU 0x80+3 ;Port 0 Bit 3
   P0_4 .EQU 0x80+4 ;Port 0 Bit 4
   P0_5 .EQU 0x80+5 ;Port 0 Bit 5
   P0_6 .EQU 0x80+6 ;Port 0 Bit 6
SP .EQU 0x81
;DPTR .EQU 0x82
DPL .EQU 0x82
DPH .EQU 0x83
RCTRIM0 .EQU 0x84
RCTRIM1 .EQU 0x85
RWK .EQU 0x86
PCON .EQU 0x87
TCON .EQU 0x88
   IT0 .EQU 0x88+0 ;Interrupt 0 Type
   IE0 .EQU 0x88+1 ;Interrupt 0 Edge
   IT1 .EQU 0x88+2 ;Interrupt 1 Type
   IE1 .EQU 0x88+3 ;Interrupt 1 Edge
   TR0 .EQU 0x88+4 ;Timer 0 Run
   TF0 .EQU 0x88+5 ;Timer 0 Flag
   TR1 .EQU 0x88+6 ;Timer 1 Run
   TF1 .EQU 0x88+7 ;Timer 1 Flag
TMOD .EQU 0x89
TL0 .EQU 0x8A
TL1 .EQU 0x8B
TH0 .EQU 0x8C
TH1 .EQU 0x8D
CKCON .EQU 0x8E
WKCON .EQU 0x8F
P1 .EQU 0x90
   IC2          .EQU 0x90+0 ;Input Capture 2
   PWM0_CH2_P10 .EQU 0x90+0 ;Pulse Width Modulator 0 Channel 2
   SPCLK        .EQU 0x90+0 ;Serial Peripheral Clock
   ICE_DAT      .EQU 0x90+6 ;In Circuit Emulator Data
   SDA_P16      .EQU 0x90+6 ;Serial Data
   TXD_1        .EQU 0x90+6 ;Transmit Data 1
   RXD_1_P16    .EQU 0x90+6 ;Receive Data 1
   ADC_CH0      .EQU 0x90+7 ;Analog Digital Converter Channel 0
   ACH0         .EQU 0x90+7 ;ADC Channel 0
   ADC0         .EQU 0x90+7 ;AtoD Channel 0
   AIN0         .EQU 0x90+7 ;Analog Input 0
   INT1         .EQU 0x90+7 ;Interrupt 1
   P10 .EQU 0x90+0 ;Port 1 Bit 0
   P16 .EQU 0x90+6 ;Port 1 Bit 6
   P17 .EQU 0x90+7 ;Port 1 Bit 7
   P1_0 .EQU 0x90+0 ;Port 1 Bit 0
   P1_6 .EQU 0x90+6 ;Port 1 Bit 6
   P1_7 .EQU 0x90+7 ;Port 1 Bit 7
SFRS .EQU 0x91 ;TA Protection
CAPCON0 .EQU 0x92
CAPCON1 .EQU 0x93
CAPCON2 .EQU 0x94
CKDIV .EQU 0x95
CKSWT .EQU 0x96 ;TA Protection
CKEN .EQU 0x97 ;TA Protection
SCON .EQU 0x98
   RI  .EQU 0x98+0 ;Receive Interrupt
   TI  .EQU 0x98+1 ;Transmit Interrupt
   RB8 .EQU 0x98+2 ;Receive Bit 8
   TB8 .EQU 0x98+3 ;Transmit Bit 8
   REN .EQU 0x98+4 ;Receive Enable
   SM2 .EQU 0x98+5 ;Serial Mode 2
   SM1 .EQU 0x98+6 ;Serial Mode 1
   SM0 .EQU 0x98+7 ;Serial Mode 0
   FE  .EQU 0x98+7 ;Framing Error
SBUF .EQU 0x99
SBUF_1 .EQU 0x9A
EIE .EQU 0x9B
EIE1 .EQU 0x9C
CHPCON .EQU 0x9F ;TA Protection
P2 .EQU 0xA0
   NRESET  .EQU 0xA0+0 ;Reset
   RST     .EQU 0xA0+0 ;Reset
   RXD     .EQU 0xA0+0 ;Receive Data
   TXD_P20 .EQU 0xA0+0 ;Transmit Data
   P20 .EQU 0xA0+0 ;Port 2 Bit 0
   P2_0 .EQU 0xA0+0 ;Port 2 Bit 0
AUXR1 .EQU 0xA2
BODCON0 .EQU 0xA3 ;TA Protection
IAPTRG .EQU 0xA4 ;TA Protection
IAPUEN .EQU 0xA5 ;TA Protection
IAPAL .EQU 0xA6
IAPAH .EQU 0xA7
IE .EQU 0xA8
   EX0  .EQU 0xA8+0 ;Enable External 0
   ET0  .EQU 0xA8+1 ;Enable Timer 0
   EX1  .EQU 0xA8+2 ;Enable External 1
   ET1  .EQU 0xA8+3 ;Enable Timer 1
   ES   .EQU 0xA8+4 ;Enable Serial
   EBOD .EQU 0xA8+5 ;Enable Brown Out Detection
   EADC .EQU 0xA8+6 ;Enable Analog Digital Converter
   EA   .EQU 0xA8+7 ;Enable All
SADDR .EQU 0xA9
WDCON .EQU 0xAA ;TA Protection
BODCON1 .EQU 0xAB ;TA Protection
P3M1 .EQU 0xAC
P3S .EQU 0xAC ;Page1
P3M2 .EQU 0xAD
P3SR .EQU 0xAD ;Page1
IAPFD .EQU 0xAE
IAPCN .EQU 0xAF
P3 .EQU 0xB0
   ADC_CH1 .EQU 0xB0+0 ;Analog Digital Converter Channel 1
   ACH1    .EQU 0xB0+0 ;ADC Channel 1
   ADC1    .EQU 0xB0+0 ;AtoD Channel 1
   AIN1    .EQU 0xB0+0 ;Analog Input 1
   INT0    .EQU 0xB0+0 ;Interrupt 0
   OSCIN   .EQU 0xB0+0 ;Oscillator In
   P30 .EQU 0xB0+0 ;Port 3 Bit 0
   P3_0 .EQU 0xB0+0 ;Port 3 Bit 0
P0M1 .EQU 0xB1
P0S .EQU 0xB1 ;Page1
P0M2 .EQU 0xB2
P0SR .EQU 0xB2 ;Page1
P1M1 .EQU 0xB3
P1S .EQU 0xB3 ;Page1
P1M2 .EQU 0xB4
P1SR .EQU 0xB4 ;Page1
P2S .EQU 0xB5
IPH .EQU 0xB7
PWMINTC .EQU 0xB7 ;Page1
IP .EQU 0xB8
   PX0  .EQU 0xB8+0 ;Priority External 0
   PT0  .EQU 0xB8+1 ;Priority Timer 0
   PX1  .EQU 0xB8+2 ;Priority External 1
   PT1  .EQU 0xB8+3 ;Priority Timer 1
   PS   .EQU 0xB8+4 ;Priority Serial
   PBOD .EQU 0xB8+5 ;Priority Brown Out Detection
   PADC .EQU 0xB8+6 ;Priority Analog Digital Converter
SADEN .EQU 0xB9
SADEN_1 .EQU 0xBA
SADDR_1 .EQU 0xBB
I2DAT .EQU 0xBC
I2STAT .EQU 0xBD
I2CLK .EQU 0xBE
I2TOC .EQU 0xBF
I2CON .EQU 0xC0
   I2CPX .EQU 0xC0+0 ;Inter-Integrated Circuit Pin eXchange
   AA    .EQU 0xC0+2 ;Acknowledge Assert
   SI    .EQU 0xC0+3 ;Status Interrupt
   STO   .EQU 0xC0+4 ;Stop
   STA   .EQU 0xC0+5 ;Start
   I2CEN .EQU 0xC0+6 ;Inter-Integrated Circuit Enable
   I     .EQU 0xC0+7 ;Increase
I2ADDR .EQU 0xC1
ADCRL .EQU 0xC2
ADCRH .EQU 0xC3
T3CON .EQU 0xC4
PWM4H .EQU 0xC4 ;Page1
RL3 .EQU 0xC5
PWM5H .EQU 0xC5 ;Page1
RH3 .EQU 0xC6
PIOCON1 .EQU 0xC6 ;Page1
TA .EQU 0xC7
T2CON .EQU 0xC8
   CM_RL2 .EQU 0xC8+0 ;Compare Reload 2
   TR2    .EQU 0xC8+2 ;Timer 2 Run
   TF2    .EQU 0xC8+7 ;Timer 2 Flag
T2MOD .EQU 0xC9
RCMP2L .EQU 0xCA
RCMP2H .EQU 0xCB
TL2 .EQU 0xCC
PWM4L .EQU 0xCC ;Page1
TH2 .EQU 0xCD
PWM5L .EQU 0xCD ;Page1
ADCMPL .EQU 0xCE
ADCMPH .EQU 0xCF
PSW .EQU 0xD0
   P   .EQU 0xD0+0 ;Parity
   F1  .EQU 0xD0+1 ;Flag 1
   OV  .EQU 0xD0+2 ;Overflow
   RS0 .EQU 0xD0+3 ;Register Select 0
   RS1 .EQU 0xD0+4 ;Register Select 1
   F0  .EQU 0xD0+5 ;Flag 0
   AC  .EQU 0xD0+6 ;Auxiliary Carry
   CY  .EQU 0xD0+7 ;Carry
PWMPH .EQU 0xD1
PWM0H .EQU 0xD2
PWM1H .EQU 0xD3
PWM2H .EQU 0xD4
PWM3H .EQU 0xD5
PNP .EQU 0xD6
FBD .EQU 0xD7
PWMCON0 .EQU 0xD8
   CLRPWM .EQU 0xD8+4 ;Clear Pulse Width Modulator
   PWMF   .EQU 0xD8+5 ;Pusle Width Modulator Flan
   LOAD   .EQU 0xD8+6 ;Load
   PWMRUN .EQU 0xD8+7 ;Pusle Width Modulator Run
PWMPL .EQU 0xD9
PWM0L .EQU 0xDA
PWM1L .EQU 0xDB
PWM2L .EQU 0xDC
PWM3L .EQU 0xDD
PIOCON0 .EQU 0xDE
PWMCON1 .EQU 0xDF
ACC .EQU 0xE0
   ACC0 .EQU 0xE0+0 ;Accumulator Bit 0
   ACC1 .EQU 0xE0+1 ;Accumulator Bit 1
   ACC2 .EQU 0xE0+2 ;Accumulator Bit 2
   ACC3 .EQU 0xE0+3 ;Accumulator Bit 3
   ACC4 .EQU 0xE0+4 ;Accumulator Bit 4
   ACC5 .EQU 0xE0+5 ;Accumulator Bit 5
   ACC6 .EQU 0xE0+6 ;Accumulator Bit 6
   ACC7 .EQU 0xE0+7 ;Accumulator Bit 7
   ACC_0 .EQU 0xE0+0 ;Accumulator Bit 0
   ACC_1 .EQU 0xE0+1 ;Accumulator Bit 1
   ACC_2 .EQU 0xE0+2 ;Accumulator Bit 2
   ACC_3 .EQU 0xE0+3 ;Accumulator Bit 3
   ACC_4 .EQU 0xE0+4 ;Accumulator Bit 4
   ACC_5 .EQU 0xE0+5 ;Accumulator Bit 5
   ACC_6 .EQU 0xE0+6 ;Accumulator Bit 6
   ACC_7 .EQU 0xE0+7 ;Accumulator Bit 7
ADCCON1 .EQU 0xE1
ADCCON2 .EQU 0xE2
ADCDLY .EQU 0xE3
C0L .EQU 0xE4
C0H .EQU 0xE5
C1L .EQU 0xE6
C1H .EQU 0xE7
ADCCON0 .EQU 0xE8
   ADCHS0  .EQU 0xE8+0 ;Analog Digital Channel Select 0
   ADCHS1  .EQU 0xE8+1 ;Analog Digital Channel Select 1
   ADCHS2  .EQU 0xE8+2 ;Analog Digital Channel Select 2
   ADCHS3  .EQU 0xE8+3 ;Analog Digital Channel Select 3
   ETGSEL0 .EQU 0xE8+4 ;External Trigger Select 0
   ETGSEL1 .EQU 0xE8+5 ;External Trigger Select 1
   ADCS    .EQU 0xE8+6 ;Analog Digital Converter Start
   ADCF    .EQU 0xE8+7 ;Analog Digital Converter Flag
PICON .EQU 0xE9
PINEN .EQU 0xEA
PIPEN .EQU 0xEB
PIF .EQU 0xEC
C2L .EQU 0xED
C2H .EQU 0xEE
EIP .EQU 0xEF
B .EQU 0xF0
   B0 .EQU 0xF0+0 ;B Bit 0
   B1 .EQU 0xF0+1 ;B Bit 1
   B2 .EQU 0xF0+2 ;B Bit 2
   B3 .EQU 0xF0+3 ;B Bit 3
   B4 .EQU 0xF0+4 ;B Bit 4
   B5 .EQU 0xF0+5 ;B Bit 5
   B6 .EQU 0xF0+6 ;B Bit 6
   B7 .EQU 0xF0+7 ;B Bit 7
   B_0 .EQU 0xF0+0 ;B Bit 0
   B_1 .EQU 0xF0+1 ;B Bit 1
   B_2 .EQU 0xF0+2 ;B Bit 2
   B_3 .EQU 0xF0+3 ;B Bit 3
   B_4 .EQU 0xF0+4 ;B Bit 4
   B_5 .EQU 0xF0+5 ;B Bit 5
   B_6 .EQU 0xF0+6 ;B Bit 6
   B_7 .EQU 0xF0+7 ;B Bit 7
CAPCON3 .EQU 0xF1
CAPCON4 .EQU 0xF2
SPCR .EQU 0xF3
SPCR2 .EQU 0xF3 ;Page1
SPSR .EQU 0xF4
SPDR .EQU 0xF5
AINDIDS .EQU 0xF6
EIPH .EQU 0xF7
SCON_1 .EQU 0xF8
   RI_1  .EQU 0xF8+0 ;Receive Interrupt UART-1
   TI_1  .EQU 0xF8+1 ;Transmit Interrupt UART-1
   RB8_1 .EQU 0xF8+2 ;Receive Bit 8 UART-1
   TB8_1 .EQU 0xF8+3 ;Transmit Bit 8 UART-1
   REN_1 .EQU 0xF8+4 ;Receive Enable UART-1
   SM2_1 .EQU 0xF8+5 ;Serial Mode 2 UART-1
   SM1_1 .EQU 0xF8+6 ;Serial Mode 1 UART-1
   SM0_1 .EQU 0xF8+7 ;Serial Mode 0 UART-1
   FE_1  .EQU 0xF8+7 ;Framing Error UART-1
PDTEN .EQU 0xF9 ;TA Protection
PDTCNT .EQU 0xFA ;TA Protection
PMEN .EQU 0xFB
PMD .EQU 0xFC
EIP1 .EQU 0xFE
EIPH1 .EQU 0xFF

;Interrupt numbers: Address = ( Number * 8 ) + 3
;Vectors are named after their corresponding interrupt
;enable register bit, so that we don't have to make up
;names and can be consisten across different 8051 MCUs
   X0_VECTOR  = 0  ; 0x03 External Interrupt 0
   T0_VECTOR  = 1  ; 0x0B Timer 0
   X1_VECTOR  = 2  ; 0x13 External Interrupt 1
   T1_VECTOR  = 3  ; 0x1B Timer 1
   S_VECTOR   = 4  ; 0x23 Serial Port 0
   T2_VECTOR  = 5  ; 0x2B Timer 2
   I2C_VECTOR = 6  ; 0x33 Inter-Integrated Circuit
   PI_VECTOR  = 7  ; 0x3B Pin Interrupt
   BOD_VECTOR = 8  ; 0x43 Brown-out
   SPI_VECTOR = 9  ; 0x4B Serial Peripheral Interface
   WDT_VECTOR = 10 ; 0x53 Watchdog timer
   ADC_VECTOR = 11 ; 0x5B Analog Digital Converter
   CAP_VECTOR = 12 ; 0x63 Input Capture
   PWM_VECTOR = 13 ; 0x6B Pulse Width Modulator
   FB_VECTOR  = 14 ; 0x73 Fault Brake Event
   S1_VECTOR  = 15 ; 0x7B Serial Port 1
   T3_VECTOR  = 16 ; 0x83 Timer 3
   WKT_VECTOR = 17 ; 0x8B Self Wake-up Timer

;.endif