; SDAS compatible header file W79E65.asm 20210823.
; For Nuvoton W79E658A W79L658A W79E658A W79L658A.

;.ifndef W79E65_ASM
;.define W79E65_ASM

P0 .EQU 0x80
   P00 .EQU 0x80+0 ;Port 0 Bit 0
   P01 .EQU 0x80+1 ;Port 0 Bit 1
   P02 .EQU 0x80+2 ;Port 0 Bit 2
   P03 .EQU 0x80+3 ;Port 0 Bit 3
   P04 .EQU 0x80+4 ;Port 0 Bit 4
   P05 .EQU 0x80+5 ;Port 0 Bit 5
   P06 .EQU 0x80+6 ;Port 0 Bit 6
   P07 .EQU 0x80+7 ;Port 0 Bit 7
   P0_0 .EQU 0x80+0 ;Port 0 Bit 0
   P0_1 .EQU 0x80+1 ;Port 0 Bit 1
   P0_2 .EQU 0x80+2 ;Port 0 Bit 2
   P0_3 .EQU 0x80+3 ;Port 0 Bit 3
   P0_4 .EQU 0x80+4 ;Port 0 Bit 4
   P0_5 .EQU 0x80+5 ;Port 0 Bit 5
   P0_6 .EQU 0x80+6 ;Port 0 Bit 6
   P0_7 .EQU 0x80+7 ;Port 0 Bit 7
SP .EQU 0x81
;DPTR .EQU 0x82
DPL .EQU 0x82
DPH .EQU 0x83
PCON .EQU 0x87
TCON .EQU 0x88
   IT0 .EQU 0x88+0 ;Interrupt 0 Type
   IE0 .EQU 0x88+1 ;Interrupt 0 Edge
   IT1 .EQU 0x88+2 ;Interrupt 1 Type
   IE1 .EQU 0x88+3 ;Interrupt 1 Edge
   TR0 .EQU 0x88+4 ;Timer 0 Run
   TF0 .EQU 0x88+5 ;Timer 0 Flag
   TR1 .EQU 0x88+6 ;Timer 1 Run
   TF1 .EQU 0x88+7 ;Timer 1 Flag
TMOD .EQU 0x89
TL0 .EQU 0x8A
TL1 .EQU 0x8B
TH0 .EQU 0x8C
TH1 .EQU 0x8D
CKCON .EQU 0x8E
P1 .EQU 0x90
   T2    .EQU 0x90+0 ;Timer 2
   T2EX  .EQU 0x90+1 ;Timer 2 Extra
   RXD_1 .EQU 0x90+2 ;Transmit Data
   TXD_1 .EQU 0x90+3 ;Receive Data
   P10 .EQU 0x90+0 ;Port 1 Bit 0
   P11 .EQU 0x90+1 ;Port 1 Bit 1
   P12 .EQU 0x90+2 ;Port 1 Bit 2
   P13 .EQU 0x90+3 ;Port 1 Bit 3
   P14 .EQU 0x90+4 ;Port 1 Bit 4
   P15 .EQU 0x90+5 ;Port 1 Bit 5
   P16 .EQU 0x90+6 ;Port 1 Bit 6
   P17 .EQU 0x90+7 ;Port 1 Bit 7
   P1_0 .EQU 0x90+0 ;Port 1 Bit 0
   P1_1 .EQU 0x90+1 ;Port 1 Bit 1
   P1_2 .EQU 0x90+2 ;Port 1 Bit 2
   P1_3 .EQU 0x90+3 ;Port 1 Bit 3
   P1_4 .EQU 0x90+4 ;Port 1 Bit 4
   P1_5 .EQU 0x90+5 ;Port 1 Bit 5
   P1_6 .EQU 0x90+6 ;Port 1 Bit 6
   P1_7 .EQU 0x90+7 ;Port 1 Bit 7
P4CONA .EQU 0x92
P4CONB .EQU 0x93
P40AL .EQU 0x94
P40AH .EQU 0x95
P41AL .EQU 0x96
P41AH .EQU 0x97
SCON .EQU 0x98
SCON0 .EQU 0x98
   RI  .EQU 0x98+0 ;Receive Interrupt
   TI  .EQU 0x98+1 ;Transmit Interrupt
   RB8 .EQU 0x98+2 ;Receive Bit 8
   TB8 .EQU 0x98+3 ;Transmit Bit 8
   REN .EQU 0x98+4 ;Receive Enable
   SM2 .EQU 0x98+5 ;Serial Mode 2
   SM1 .EQU 0x98+6 ;Serial Mode 1
   SM0 .EQU 0x98+7 ;(WR)Serial Mode 0
   FE  .EQU 0x98+7 ;(RD)Framing Error
SBUF .EQU 0x99
P42AL .EQU 0x9A
P42AH .EQU 0x9B
P43AL .EQU 0x9C
P43AH .EQU 0x9D
CHPCON .EQU 0x9F
P2 .EQU 0xA0
   P20 .EQU 0xA0+0 ;Port 2 Bit 0
   P21 .EQU 0xA0+1 ;Port 2 Bit 1
   P22 .EQU 0xA0+2 ;Port 2 Bit 2
   P23 .EQU 0xA0+3 ;Port 2 Bit 3
   P24 .EQU 0xA0+4 ;Port 2 Bit 4
   P25 .EQU 0xA0+5 ;Port 2 Bit 5
   P26 .EQU 0xA0+6 ;Port 2 Bit 6
   P27 .EQU 0xA0+7 ;Port 2 Bit 7
   P2_0 .EQU 0xA0+0 ;Port 2 Bit 0
   P2_1 .EQU 0xA0+1 ;Port 2 Bit 1
   P2_2 .EQU 0xA0+2 ;Port 2 Bit 2
   P2_3 .EQU 0xA0+3 ;Port 2 Bit 3
   P2_4 .EQU 0xA0+4 ;Port 2 Bit 4
   P2_5 .EQU 0xA0+5 ;Port 2 Bit 5
   P2_6 .EQU 0xA0+6 ;Port 2 Bit 6
   P2_7 .EQU 0xA0+7 ;Port 2 Bit 7
XRAMAH .EQU 0xA1
P4CSIN .EQU 0xA2
P4 .EQU 0xA5
IE .EQU 0xA8
   EX0  .EQU 0xA8+0 ;Enable External 0
   ET0  .EQU 0xA8+1 ;Enable Timer 0
   EX1  .EQU 0xA8+2 ;Enable External 1
   ET1  .EQU 0xA8+3 ;Enable Timer 1
   ES   .EQU 0xA8+4 ;Enable Serial
   ET2  .EQU 0xA8+5 ;Enable Timer 2
   EA   .EQU 0xA8+7 ;Enable All
SADDR .EQU 0xA9
ROMCON .EQU 0xAB
SFRAL .EQU 0xAC
SFRAH .EQU 0xAD
SFDFD .EQU 0xAE
SFRCN .EQU 0xAF
P3 .EQU 0xB0
   RXD  .EQU 0xB0+0 ;Receive Data
   TXD  .EQU 0xB0+1 ;Transmit Data
   INT0 .EQU 0xB0+2 ;Interrupt 0
   INT1 .EQU 0xB0+3 ;Interrupt 1
   T0   .EQU 0xB0+4 ;Timer 0
   T1   .EQU 0xB0+5 ;Timer 1
   WR   .EQU 0xB0+6 ;Write
   RD   .EQU 0xB0+7 ;Read
   P30 .EQU 0xB0+0 ;Port 3 Bit 0
   P31 .EQU 0xB0+1 ;Port 3 Bit 1
   P32 .EQU 0xB0+2 ;Port 3 Bit 2
   P33 .EQU 0xB0+3 ;Port 3 Bit 3
   P34 .EQU 0xB0+4 ;Port 3 Bit 4
   P35 .EQU 0xB0+5 ;Port 3 Bit 5
   P36 .EQU 0xB0+6 ;Port 3 Bit 6
   P37 .EQU 0xB0+7 ;Port 3 Bit 7
   P3_0 .EQU 0xB0+0 ;Port 3 Bit 0
   P3_1 .EQU 0xB0+1 ;Port 3 Bit 1
   P3_2 .EQU 0xB0+2 ;Port 3 Bit 2
   P3_3 .EQU 0xB0+3 ;Port 3 Bit 3
   P3_4 .EQU 0xB0+4 ;Port 3 Bit 4
   P3_5 .EQU 0xB0+5 ;Port 3 Bit 5
   P3_6 .EQU 0xB0+6 ;Port 3 Bit 6
   P3_7 .EQU 0xB0+7 ;Port 3 Bit 7
P5 .EQU 0xB1
P6 .EQU 0xB2
P7 .EQU 0xB3
IP .EQU 0xB8
   PX0  .EQU 0xB8+0 ;Priority External 0
   PT0  .EQU 0xB8+1 ;Priority Timer 0
   PX1  .EQU 0xB8+2 ;Priority External 1
   PT1  .EQU 0xB8+3 ;Priority Timer 1
   PS   .EQU 0xB8+4 ;Priority Serial
   PT2  .EQU 0xB8+5 ;Priority Timer 2
SADEN .EQU 0xB9
T2CON .EQU 0xC8
   CP_RL2 .EQU 0xC8+0 ;Capture Reload 2
   C_T2   .EQU 0xC8+1 ;Counter Timer 2
   TR2    .EQU 0xC8+2 ;Timer 2 Run
   EXEN2  .EQU 0xC8+3 ;External Enable 2
   TCLK   .EQU 0xC8+4 ;Transmit Clock
   RCLK   .EQU 0xC8+5 ;Receive Clock
   EXF2   .EQU 0xC8+6 ;External Flag 2
   TF2    .EQU 0xC8+7 ;Timer 2 Flag
T2MOD .EQU 0xC9
RCAP2L .EQU 0xCA
RACP2H .EQU 0xCB
TL2 .EQU 0xCC
TH2 .EQU 0xCD
PWMCON2 .EQU 0xCE
PWM4 .EQU 0xCF
PSW .EQU 0xD0
   P   .EQU 0xD0+0 ;Parity
   F1  .EQU 0xD0+1 ;Flag 1
   OV  .EQU 0xD0+2 ;Overflow
   RS0 .EQU 0xD0+3 ;Register Select 0
   RS1 .EQU 0xD0+4 ;Register Select 1
   F0  .EQU 0xD0+5 ;Flag 0
   AC  .EQU 0xD0+6 ;Auxiliary Carry
   CY  .EQU 0xD0+7 ;Carry
WDCON .EQU 0xD8
   RWT  .EQU 0xD8+0 ;Reset Watchdog Timer
   EWT  .EQU 0xD8+1 ;Enable Watchdog Timer
   WTRF .EQU 0xD8+2 ;Watchdog Reset Flag
   WDIF .EQU 0xD8+3 ;Watchdog Interrupt Flag
   POR  .EQU 0xD8+6 ;Power On Reset
PWMP .EQU 0xD9
PMW0 .EQU 0xDA
PWM1 .EQU 0xDB
PWMCON1 .EQU 0xDC
PWM2 .EQU 0xDD
PWM3 .EQU 0xDE
ACC .EQU 0xE0
   ACC0 .EQU 0xE0+0 ;Accumulator Bit 0
   ACC1 .EQU 0xE0+1 ;Accumulator Bit 1
   ACC2 .EQU 0xE0+2 ;Accumulator Bit 2
   ACC3 .EQU 0xE0+3 ;Accumulator Bit 3
   ACC4 .EQU 0xE0+4 ;Accumulator Bit 4
   ACC5 .EQU 0xE0+5 ;Accumulator Bit 5
   ACC6 .EQU 0xE0+6 ;Accumulator Bit 6
   ACC7 .EQU 0xE0+7 ;Accumulator Bit 7
   ACC_0 .EQU 0xE0+0 ;Accumulator Bit 0
   ACC_1 .EQU 0xE0+1 ;Accumulator Bit 1
   ACC_2 .EQU 0xE0+2 ;Accumulator Bit 2
   ACC_3 .EQU 0xE0+3 ;Accumulator Bit 3
   ACC_4 .EQU 0xE0+4 ;Accumulator Bit 4
   ACC_5 .EQU 0xE0+5 ;Accumulator Bit 5
   ACC_6 .EQU 0xE0+6 ;Accumulator Bit 6
   ACC_7 .EQU 0xE0+7 ;Accumulator Bit 7
EIE .EQU 0xE8
   EI2C1 .EQU 0xE8+0 ;Enable I2C Channel 1
   EI2C2 .EQU 0xE8+1 ;Enable I2C Channel 2
   EWDI  .EQU 0xE8+4 ;Enable Watchdog Interrupt
I2CON .EQU 0xE9
I2ADDR10 .EQU 0xEA
I2ADDR11 .EQU 0xEB
I2DATA .EQU 0xEC
I2STATUS .EQU 0xED
I2CLK .EQU 0xEE
I2TIMER .EQU 0xEF
B .EQU 0xF0
   B0 .EQU 0xF0+0 ;B Bit 0
   B1 .EQU 0xF0+1 ;B Bit 1
   B2 .EQU 0xF0+2 ;B Bit 2
   B3 .EQU 0xF0+3 ;B Bit 3
   B4 .EQU 0xF0+4 ;B Bit 4
   B5 .EQU 0xF0+5 ;B Bit 5
   B6 .EQU 0xF0+6 ;B Bit 6
   B7 .EQU 0xF0+7 ;B Bit 7
   B_0 .EQU 0xF0+0 ;B Bit 0
   B_1 .EQU 0xF0+1 ;B Bit 1
   B_2 .EQU 0xF0+2 ;B Bit 2
   B_3 .EQU 0xF0+3 ;B Bit 3
   B_4 .EQU 0xF0+4 ;B Bit 4
   B_5 .EQU 0xF0+5 ;B Bit 5
   B_6 .EQU 0xF0+6 ;B Bit 6
   B_7 .EQU 0xF0+7 ;B Bit 7
EIP .EQU 0xF8
   PI2C1 .EQU 0xF8+0 ;Priority I2C Channel 1
   PI2C2 .EQU 0xF8+1 ;Priority I2C Channel 2
   PWDI  .EQU 0xF8+4 ;Priority Watchdog Interrupt
I2CON2 .EQU 0xF9
I2ADDR20 .EQU 0xFA
I2ADDR21 .EQU 0xFB
I2DATA2 .EQU 0xFC
I2STATUS2 .EQU 0xFD
I2CLK2 .EQU 0xFE
I2TIMER2 .EQU 0xFF

;.endif