; SDAS compatible header file ML5.asm 20210823.
; For Nuvoton ML51 ML54 ML56 series.

;.ifndef ML5_ASM
;.define ML5_ASM

;  ML56 SFR BYTE page 0

P0 .EQU 0x80
   P00 .EQU 0x80+0 ;Port 0 Bit 0
   P01 .EQU 0x80+1 ;Port 0 Bit 1
   P02 .EQU 0x80+2 ;Port 0 Bit 2
   P03 .EQU 0x80+3 ;Port 0 Bit 3
   P04 .EQU 0x80+4 ;Port 0 Bit 4
   P05 .EQU 0x80+5 ;Port 0 Bit 5
   P06 .EQU 0x80+6 ;Port 0 Bit 6
   P07 .EQU 0x80+7 ;Port 0 Bit 7
   P0_0 .EQU 0x80+0 ;Port 0 Bit 0
   P0_1 .EQU 0x80+1 ;Port 0 Bit 1
   P0_2 .EQU 0x80+2 ;Port 0 Bit 2
   P0_3 .EQU 0x80+3 ;Port 0 Bit 3
   P0_4 .EQU 0x80+4 ;Port 0 Bit 4
   P0_5 .EQU 0x80+5 ;Port 0 Bit 5
   P0_6 .EQU 0x80+6 ;Port 0 Bit 6
   P0_7 .EQU 0x80+7 ;Port 0 Bit 7
   ; See data sheet for additional pin names.
SP .EQU 0x81
;DPTR .EQU 0x82
DPL .EQU 0x82
DPH .EQU 0x83
RCTRIM0 .EQU 0x84
RCTRIM1 .EQU 0x85
RWKL .EQU 0x86
PCON .EQU 0x87
TCON .EQU 0x88
   IT0 .EQU 0x88+0 ;Interrupt 0 Type
   IE0 .EQU 0x88+1 ;Interrupt 0 Edge
   IT1 .EQU 0x88+2 ;Interrupt 1 Type
   IE1 .EQU 0x88+3 ;Interrupt 1 Edge
   TR0 .EQU 0x88+4 ;Timer 0 Run
   TF0 .EQU 0x88+5 ;Timer 0 Flag
   TR1 .EQU 0x88+6 ;Timer 1 Run
   TF1 .EQU 0x88+7 ;Timer 1 Flag
TMOD .EQU 0x89
TL0 .EQU 0x8A
TL1 .EQU 0x8B
TH0 .EQU 0x8C
TH1 .EQU 0x8D
CKCON .EQU 0x8E
WKCON .EQU 0x8F
P1 .EQU 0x90
   P10 .EQU 0x90+0 ;Port 1 Bit 0
   P11 .EQU 0x90+1 ;Port 1 Bit 1
   P12 .EQU 0x90+2 ;Port 1 Bit 2
   P13 .EQU 0x90+3 ;Port 1 Bit 3
   P14 .EQU 0x90+4 ;Port 1 Bit 4
   P15 .EQU 0x90+5 ;Port 1 Bit 5
   P16 .EQU 0x90+6 ;Port 1 Bit 6
   P17 .EQU 0x90+7 ;Port 1 Bit 7
   P1_0 .EQU 0x90+0 ;Port 1 Bit 0
   P1_1 .EQU 0x90+1 ;Port 1 Bit 1
   P1_2 .EQU 0x90+2 ;Port 1 Bit 2
   P1_3 .EQU 0x90+3 ;Port 1 Bit 3
   P1_4 .EQU 0x90+4 ;Port 1 Bit 4
   P1_5 .EQU 0x90+5 ;Port 1 Bit 5
   P1_6 .EQU 0x90+6 ;Port 1 Bit 6
   P1_7 .EQU 0x90+7 ;Port 1 Bit 7
   ; See data sheet for additional pin names.
SFRS .EQU 0x91
DMA0CR0 .EQU 0x92
DMA0MAL .EQU 0x93
DMA0CNT .EQU 0x94
DMA0CCNT .EQU 0x95
CKSWT .EQU 0x96
CKEN .EQU 0x97
SCON .EQU 0x98
   RI  .EQU 0x98+0 ;Receive Interrupt
   TI  .EQU 0x98+1 ;Transmit Interrupt
   RB8 .EQU 0x98+2 ;Receive Bit 8
   TB8 .EQU 0x98+3 ;Transmit Bit 8
   REN .EQU 0x98+4 ;Receive Enable
   SM2 .EQU 0x98+5 ;Serial Mode 2
   SM1 .EQU 0x98+6 ;Serial Mode 1
   SM0 .EQU 0x98+7 ;Serial Mode 0
   FE  .EQU 0x98+7 ;Framing Error
SBUF .EQU 0x99
SBUF1 .EQU 0x9A
EIE0 .EQU 0x9B
EIE1 .EQU 0x9C
RSR .EQU 0x9D
CHPCON .EQU 0x9F
P2 .EQU 0xA0
   ACMP0_N1 .EQU 0xA0+0 ;Analog Comparator 0 Negative 1
   ACMP_P2  .EQU 0xA0+1 ;Analog Comparator Positive 2
   ACMP1_N0 .EQU 0xA0+2 ;Analog Comparator 1 Negative 0
   ACMP_P1  .EQU 0xA0+3 ;Analog Comparator Positive 1
   ACMP0_N0 .EQU 0xA0+4 ;Analog Comparator 0 Negative 0
   ACMP_P0  .EQU 0xA0+5 ;Analog Comparator Positive 0
   ADC_CH5  .EQU 0xA0+0 ;ADC Channel 5
   ACH5     .EQU 0xA0+0 ;ADC Channel 5
   ADC5     .EQU 0xA0+0 ;AtoD Channel 5
   AIN5     .EQU 0xA0+0 ;Analog Input 5
   ADC_CH4  .EQU 0xA0+1 ;ADC Channel 4
   ACH4     .EQU 0xA0+1 ;ADC Channel 4
   ADC4     .EQU 0xA0+1 ;AtoD Channel 4
   AIN4     .EQU 0xA0+1 ;Analog Input 4
   ADC_CH3  .EQU 0xA0+2 ;ADC Channel 3
   ACH3     .EQU 0xA0+2 ;ADC Channel 3
   ADC3     .EQU 0xA0+2 ;AtoD Channel 3
   AIN3     .EQU 0xA0+2 ;Analog Input 3
   ADC_CH2  .EQU 0xA0+3 ;ADC Channel 2
   ACH2     .EQU 0xA0+3 ;ADC Channel 2
   ADC2     .EQU 0xA0+3 ;AtoD Channel 2
   AIN2     .EQU 0xA0+3 ;Analog Input 2
   ADC_CH1  .EQU 0xA0+4 ;ADC Channel 1
   ACH1     .EQU 0xA0+4 ;ADC Channel 1
   ADC1     .EQU 0xA0+4 ;AtoD Channel 1
   AIN1     .EQU 0xA0+4 ;Analog Input 1
   ADC_CH0  .EQU 0xA0+5 ;ADC Channel 0
   ACH0     .EQU 0xA0+5 ;ADC Channel 0
   ADC0     .EQU 0xA0+5 ;AtoD Channel 0
   AIN0     .EQU 0xA0+5 ;Analog Input 0
   ADC_CH15 .EQU 0xA0+7 ;ADC Channel 15
   ACH15    .EQU 0xA0+7 ;ADC Channel 15
   ADC15    .EQU 0xA0+7 ;AtoD Channel 15
   AIN15    .EQU 0xA0+7 ;Analog Input 15
   P20 .EQU 0xA0+0 ;Port 2 Bit 0
   P21 .EQU 0xA0+1 ;Port 2 Bit 1
   P22 .EQU 0xA0+2 ;Port 2 Bit 2
   P23 .EQU 0xA0+3 ;Port 2 Bit 3
   P24 .EQU 0xA0+4 ;Port 2 Bit 4
   P25 .EQU 0xA0+5 ;Port 2 Bit 5
   P26 .EQU 0xA0+6 ;Port 2 Bit 6
   P27 .EQU 0xA0+7 ;Port 2 Bit 7
   P2_0 .EQU 0xA0+0 ;Port 2 Bit 0
   P2_1 .EQU 0xA0+1 ;Port 2 Bit 1
   P2_2 .EQU 0xA0+2 ;Port 2 Bit 2
   P2_3 .EQU 0xA0+3 ;Port 2 Bit 3
   P2_4 .EQU 0xA0+4 ;Port 2 Bit 4
   P2_5 .EQU 0xA0+5 ;Port 2 Bit 5
   P2_6 .EQU 0xA0+6 ;Port 2 Bit 6
   P2_7 .EQU 0xA0+7 ;Port 2 Bit 7
   ; See data sheet for additional pin names.
ADCCON0 .EQU 0xA1
AUXR0 .EQU 0xA2
BODCON0 .EQU 0xA3
IAPTRG .EQU 0xA4
IAPUEN .EQU 0xA5
IAPAL .EQU 0xA6
IAPAH .EQU 0xA7 ;(only byte addressable)
IE .EQU 0xA8
   EX0  .EQU 0xA8+0 ;Enable External 0
   ET0  .EQU 0xA8+1 ;Enable Timer 0
   EX1  .EQU 0xA8+2 ;Enable External 1
   ET1  .EQU 0xA8+3 ;Enable Timer 1
   ES   .EQU 0xA8+4 ;Enable Serial
   EBOD .EQU 0xA8+5 ;Enable Brown Out Detector
   EADC .EQU 0xA8+6 ;Enable Analog Digital Converter
   EA   .EQU 0xA8+7 ;Enable All
SADDR0 .EQU 0xA9
WDCON .EQU 0xAA
BODCON1 .EQU 0xAB
EIP2 .EQU 0xAC
EIPH2 .EQU 0xAD
IAPFD .EQU 0xAE
IAPCN .EQU 0xAF
P3 .EQU 0xB0
   ACMP_P3  .EQU 0xB0+0 ;Analog Comparator Positive 3
   ACMP1_N1 .EQU 0xB0+1 ;Analog Comparator 1 Negative 1
   ADC_CH10 .EQU 0xB0+0 ;ADC Channel 10
   ACH10    .EQU 0xB0+0 ;ADC Channel 10
   ADC10    .EQU 0xB0+0 ;AtoD Channel 10
   AIN10    .EQU 0xB0+0 ;Analog Input 10
   ADC_CH6  .EQU 0xB0+1 ;ADC Channel 6
   ACH6     .EQU 0xB0+1 ;ADC Channel 6
   ADC6     .EQU 0xB0+1 ;AtoD Channel 6
   AIN6     .EQU 0xB0+1 ;Analog Input 6
   ADC_CH7  .EQU 0xB0+2 ;ADC Channel 7
   ACH7     .EQU 0xB0+2 ;ADC Channel 7
   ADC7     .EQU 0xB0+2 ;AtoD Channel 7
   AIN7     .EQU 0xB0+2 ;Analog Input 7
   P30 .EQU 0xB0+0 ;Port 3 Bit 0
   P31 .EQU 0xB0+1 ;Port 3 Bit 1
   P32 .EQU 0xB0+2 ;Port 3 Bit 2
   P33 .EQU 0xB0+3 ;Port 3 Bit 3
   P34 .EQU 0xB0+4 ;Port 3 Bit 4
   P35 .EQU 0xB0+5 ;Port 3 Bit 5
   P36 .EQU 0xB0+6 ;Port 3 Bit 6
   P37 .EQU 0xB0+7 ;Port 3 Bit 7
   P3_0 .EQU 0xB0+0 ;Port 3 Bit 0
   P3_1 .EQU 0xB0+1 ;Port 3 Bit 1
   P3_2 .EQU 0xB0+2 ;Port 3 Bit 2
   P3_3 .EQU 0xB0+3 ;Port 3 Bit 3
   P3_4 .EQU 0xB0+4 ;Port 3 Bit 4
   P3_5 .EQU 0xB0+5 ;Port 3 Bit 5
   P3_6 .EQU 0xB0+6 ;Port 3 Bit 6
   P3_7 .EQU 0xB0+7 ;Port 3 Bit 7
   ; See data sheet for additional pin names.
P5 .EQU 0xB1 ;(only byte addressable)
   P50  = 0x01 ;Port 5 Bit 0
   P51  = 0x02 ;Port 5 Bit 1
   P52  = 0x04 ;Port 5 Bit 2
   P53  = 0x08 ;Port 5 Bit 3
   P54  = 0x10 ;Port 5 Bit 4
   P55  = 0x20 ;Port 5 Bit 5
   P56  = 0x40 ;Port 5 Bit 6
   P57  = 0x80 ;Port 5 Bit 7
   P5_0 = 0x01 ;Port 5 Bit 0
   P5_1 = 0x02 ;Port 5 Bit 1
   P5_2 = 0x04 ;Port 5 Bit 2
   P5_3 = 0x08 ;Port 5 Bit 3
   P5_4 = 0x10 ;Port 5 Bit 4
   P5_5 = 0x20 ;Port 5 Bit 5
   P5_6 = 0x40 ;Port 5 Bit 6
   P5_7 = 0x80 ;Port 5 Bit 7
   ; See data sheet for additional pin names.
I2C1ADDR0 .EQU 0xB2
I2C1DAT .EQU 0xB3
I2C1STAT .EQU 0xB4
I2C1CLK .EQU 0xB5
I2C1TOC .EQU 0xB6
IPH .EQU 0xB7
IP .EQU 0xB8
   PX0  .EQU 0xB8+0 ;Priority External 0
   PT0  .EQU 0xB8+1 ;Priority Timer 0
   PX1  .EQU 0xB8+2 ;Priority External 1
   PT1  .EQU 0xB8+3 ;Priority Timer 1
   PS   .EQU 0xB8+4 ;Priority Serial
   PBOD .EQU 0xB8+5 ;Priority Brown Out Detection
   PADC .EQU 0xB8+6 ;Priority Analog Digital Converter
SADEN .EQU 0xB9
SADEN1 .EQU 0xBA
SADDR1 .EQU 0xBB
I2C0DAT .EQU 0xBC
I2C0STAT .EQU 0xBD
I2C0CLK .EQU 0xBE
I2C0TOC .EQU 0xBF
I2C0CON .EQU 0xC0
   I2CPX0 .EQU 0xC0+0 ;Inter-Integrated Circuit Pin eXchange 0
   AA0    .EQU 0xC0+2 ;Acknowledge Assert 0
   SI0    .EQU 0xC0+3 ;Status Interrupt 0
   STO0   .EQU 0xC0+4 ;Stop 0
   STA0   .EQU 0xC0+5 ;Start 0
   I2CEN0 .EQU 0xC0+6 ;Inter-Integrated Circuit Enable 0
   I0     .EQU 0xC0+7 ;Increase 0
I2C0ADDR0 .EQU 0xC1
ADCRL .EQU 0xC2
ADCRH .EQU 0xC3
T3CON .EQU 0xC4
RL3 .EQU 0xC5
RH3 .EQU 0xC6
TA .EQU 0xC7
T2CON .EQU 0xC8
   CM_RL2 .EQU 0xC8+0 ;Compare Reload 2
   TR2    .EQU 0xC8+2 ;Timer 2 Run
   TF2    .EQU 0xC8+7 ;Timer 2 Flag
T2MOD .EQU 0xC9
PIF .EQU 0xCA
ADCBAL .EQU 0xCB
TL2 .EQU 0xCC
TH2 .EQU 0xCD
ADCMPL .EQU 0xCE
ADCMPH .EQU 0xCF
PSW .EQU 0xD0
   P   .EQU 0xD0+0 ;Parity
   F1  .EQU 0xD0+1 ;Flag 1
   OV  .EQU 0xD0+2 ;Overflow
   RS0 .EQU 0xD0+3 ;Register Select 0
   RS1 .EQU 0xD0+4 ;Register Select 1
   F0  .EQU 0xD0+5 ;Flag 0
   AC  .EQU 0xD0+6 ;Auxiliary Carry
   CY  .EQU 0xD0+7 ;Carry
PWM0CON0 .EQU 0xD1
ACMPCR0 .EQU 0xD2
ACMPCR1 .EQU 0xD3
ACMPSR .EQU 0xD4
ACMPVREF .EQU 0xD5
SC0CR0 .EQU 0xD6
SC0CR1 .EQU 0xD7
P4 .EQU 0xD8
   P40 .EQU 0xD8+0 ;Port 4 Bit 0
   P41 .EQU 0xD8+1 ;Port 4 Bit 1
   P42 .EQU 0xD8+2 ;Port 4 Bit 2
   P43 .EQU 0xD8+3 ;Port 4 Bit 3
   P44 .EQU 0xD8+4 ;Port 4 Bit 4
   P45 .EQU 0xD8+5 ;Port 4 Bit 5
   P46 .EQU 0xD8+6 ;Port 4 Bit 6
   P47 .EQU 0xD8+7 ;Port 4 Bit 7
   P4_0 .EQU 0xD8+0 ;Port 4 Bit 0
   P4_1 .EQU 0xD8+1 ;Port 4 Bit 1
   P4_2 .EQU 0xD8+2 ;Port 4 Bit 2
   P4_3 .EQU 0xD8+3 ;Port 4 Bit 3
   P4_4 .EQU 0xD8+4 ;Port 4 Bit 4
   P4_5 .EQU 0xD8+5 ;Port 4 Bit 5
   P4_6 .EQU 0xD8+6 ;Port 4 Bit 6
   P4_7 .EQU 0xD8+7 ;Port 4 Bit 7
   ; See data sheet for additional pin names.
SC0DR .EQU 0xD9
SC0EGT .EQU 0xDA
SC0ETURD0 .EQU 0xDB
SC0ETURD1 .EQU 0xDC
SC0IE .EQU 0xDD
SC0IS .EQU 0xDE
SC0TSR .EQU 0xDF
ACC .EQU 0xE0
   ACC0 .EQU 0xE0+0 ;Accumulator Bit 0
   ACC1 .EQU 0xE0+1 ;Accumulator Bit 1
   ACC2 .EQU 0xE0+2 ;Accumulator Bit 2
   ACC3 .EQU 0xE0+3 ;Accumulator Bit 3
   ACC4 .EQU 0xE0+4 ;Accumulator Bit 4
   ACC5 .EQU 0xE0+5 ;Accumulator Bit 5
   ACC6 .EQU 0xE0+6 ;Accumulator Bit 6
   ACC7 .EQU 0xE0+7 ;Accumulator Bit 7
   ACC_0 .EQU 0xE0+0 ;Accumulator Bit 0
   ACC_1 .EQU 0xE0+1 ;Accumulator Bit 1
   ACC_2 .EQU 0xE0+2 ;Accumulator Bit 2
   ACC_3 .EQU 0xE0+3 ;Accumulator Bit 3
   ACC_4 .EQU 0xE0+4 ;Accumulator Bit 4
   ACC_5 .EQU 0xE0+5 ;Accumulator Bit 5
   ACC_6 .EQU 0xE0+6 ;Accumulator Bit 6
   ACC_7 .EQU 0xE0+7 ;Accumulator Bit 7
ADCCON1 .EQU 0xE1
ADCCON2 .EQU 0xE2
ADCDLY .EQU 0xE3
ADCBAH .EQU 0xE4
ADCSN .EQU 0xE5
ADCCN .EQU 0xE6
ADCSR .EQU 0xE7
I2C1CON .EQU 0xE8
   I2CPX1 .EQU 0xE8+0 ;Inter-Integrated Circuit Pin eXchange 1
   AA1    .EQU 0xE8+2 ;Acknowledge Assert 1
   SI1    .EQU 0xE8+3 ;Status Interrupt 1
   STO1   .EQU 0xE8+4 ;Stop 1
   STA1   .EQU 0xE8+5 ;Start 1
   I2CEN1 .EQU 0xE8+6 ;Inter-Integrated Circuit Enable 1
   I1     .EQU 0xE8+7 ;Increase 1
DMA0TSR .EQU 0xE9
MTM0DAL .EQU 0xEA
DMA1CR0 .EQU 0xEB
DMA1MAL .EQU 0xEC
DMA1CNT .EQU 0xED
DMA1CCNT .EQU 0xEE
EIP0 .EQU 0xEF
B .EQU 0xF0
   B0 .EQU 0xF0+0 ;B Bit 0
   B1 .EQU 0xF0+1 ;B Bit 1
   B2 .EQU 0xF0+2 ;B Bit 2
   B3 .EQU 0xF0+3 ;B Bit 3
   B4 .EQU 0xF0+4 ;B Bit 4
   B5 .EQU 0xF0+5 ;B Bit 5
   B6 .EQU 0xF0+6 ;B Bit 6
   B7 .EQU 0xF0+7 ;B Bit 7
   B_0 .EQU 0xF0+0 ;B Bit 0
   B_1 .EQU 0xF0+1 ;B Bit 1
   B_2 .EQU 0xF0+2 ;B Bit 2
   B_3 .EQU 0xF0+3 ;B Bit 3
   B_4 .EQU 0xF0+4 ;B Bit 4
   B_5 .EQU 0xF0+5 ;B Bit 5
   B_6 .EQU 0xF0+6 ;B Bit 6
   B_7 .EQU 0xF0+7 ;B Bit 7
DMA1TSR .EQU 0xF1
MTM1DAL .EQU 0xF2
SPI0CR0 .EQU 0xF3
SPI0SR .EQU 0xF4
SPI0DR .EQU 0xF5
DMA0BAH .EQU 0xF6
EIPH0 .EQU 0xF7
S1CON .EQU 0xF8
SCON_1 .EQU 0xF8
   RI_1  .EQU 0xF8+0 ;Receive Interrupt UART-1
   TI_1  .EQU 0xF8+1 ;Transmit Interrupt UART-1
   RB8_1 .EQU 0xF8+2 ;Receive Bit 8 UART-1
   TB8_1 .EQU 0xF8+3 ;Transmit Bit 8 UART-1
   REN_1 .EQU 0xF8+4 ;Receive Enable UART-1
   SM2_1 .EQU 0xF8+5 ;Serial Mode 2 UART-1
   SM1_1 .EQU 0xF8+6 ;Serial Mode 1 UART-1
   SM0_1 .EQU 0xF8+7 ;(WR)Serial Mode 0 UART-1
   FE_1  .EQU 0xF8+7 ;(RD)Framing Error UART-1
SPI1CR0 .EQU 0xF9
SPI1CR1 .EQU 0xFA
SPI1SR .EQU 0xFB
SPI1DR .EQU 0xFC
DMA1BAH .EQU 0xFD
EIP1 .EQU 0xFE
EIPH1 .EQU 0xFF

;  ML56 SFR BYTE page 1

LIRCTRIM .EQU 0x84
XLTCON .EQU 0x85
CWKL .EQU 0x86
P0DW .EQU 0x8A
P1DW .EQU 0x8B
P2DW .EQU 0x8C
P3DW .EQU 0x8D
P4DW .EQU 0x8E
P5DW .EQU 0x8F

P0UP .EQU 0x92
P1UP .EQU 0x93
P2UP .EQU 0x94
P3UP .EQU 0x95
P4UP .EQU 0x96
P5UP .EQU 0x97
P0S .EQU 0x99
P0SR .EQU 0x9A
P1S .EQU 0x9B
P1SR .EQU 0x9C
P2S .EQU 0x9D
P2SR .EQU 0x9E

PIPS0 .EQU 0xA1
PIPS1 .EQU 0xA2
PIPS2 .EQU 0xA3
PIPS3 .EQU 0xA4
PIPS4 .EQU 0xA5
PIPS5 .EQU 0xA6
PIPS6 .EQU 0xA7
VRFCON .EQU 0xA9
VRFTRIM .EQU 0xAA
ACMPCR2 .EQU 0xAB
P3S .EQU 0xAC
P3SR .EQU 0xAD
P5SR .EQU 0xAE
PIPS7 .EQU 0xAF

P0M1 .EQU 0xB1
P0M2 .EQU 0xB2
P1M1 .EQU 0xB3
P1M2 .EQU 0xB4
P2M1 .EQU 0xB5
P2M2 .EQU 0xB6
PWM0INTC .EQU 0xB7
P4M1 .EQU 0xB9
P4M2 .EQU 0xBA
P4S .EQU 0xBB
P4SR .EQU 0xBC
P5M1 .EQU 0xBD
P5M2 .EQU 0xBE
P5S .EQU 0xBF

CKDIV .EQU 0xC1
P3M1 .EQU 0xC2
P3M2 .EQU 0xC3
PWM0C4H .EQU 0xC4
PWM0C5H .EQU 0xC5
PORDIS .EQU 0xC6
AUXR1 .EQU 0xC9
RCMP2L .EQU 0xCA
RCMP2H .EQU 0xCB
PWM0C4L .EQU 0xCC
PWM0C5L .EQU 0xCD
AINDIDS0 .EQU 0xCE

PWM0PH .EQU 0xD1
PWM0C0H .EQU 0xD2
PWM0C1H .EQU 0xD3
PWM0C2H .EQU 0xD4
PWM0C3H .EQU 0xD5
PWM0NP .EQU 0xD6
PWM0FBD .EQU 0xD7
PWM0PL .EQU 0xD9
PWM0C0L .EQU 0xDA
PWM0C1L .EQU 0xDB
PWM0C2L .EQU 0xDC
PWM0C3L .EQU 0xDD
PWM0CON1 .EQU 0xDF

CAPCON0 .EQU 0xE1
CAPCON1 .EQU 0xE2
CAPCON2 .EQU 0xE3
C0L .EQU 0xE4
C0H .EQU 0xE5
C1L .EQU 0xE6
C1H .EQU 0xE7
PICON .EQU 0xE9
PINEN .EQU 0xEA
PIPEN .EQU 0xEB
C2L .EQU 0xED
C2H .EQU 0xEE
LDOTRIM .EQU 0xEF

SPI0CR1 .EQU 0xF3
PWM0DTEN .EQU 0xF9
PWM0DTCNT .EQU 0xFA
PWM0MEN .EQU 0xFB
PWM0MD .EQU 0xFC
LVRFLTEN .EQU 0xFD
LVRDIS .EQU 0xFF

;  ML56 SFR BYTE page 2

P6M1 .EQU 0x84
P6M2 .EQU 0x85
PWM1PH .EQU 0x86
PWM1C0H .EQU 0x8A
PWM1C1H .EQU 0x8B
PWM1MD .EQU 0x8C
PWM1MEN .EQU 0x8D
P6SR .EQU 0x8E
P6DW .EQU 0x8F

P6MF10 .EQU 0x92
P6MF32 .EQU 0x93
P6MF54 .EQU 0x94
P6MF76 .EQU 0x95
P6S .EQU 0x96
P6UP .EQU 0x97
PWM1PL .EQU 0x99
PWM1C0L .EQU 0x9A
PWM1C1L .EQU 0x9B
PWM1CON0 .EQU 0x9C
PWM1CON1 .EQU 0x9D
PWM1INTC .EQU 0x9E

I2C0ADDR1 .EQU 0xA1
I2C0ADDR2 .EQU 0xA2
I2C0ADDR3 .EQU 0xA3
I2C1ADDR1 .EQU 0xA4
I2C1ADDR2 .EQU 0xA5
I2C1ADDR3 .EQU 0xA6
P6 .EQU 0xA7
   ADC_CH14 = 0x10 ;ADC Channel 14
   ACH14    = 0x10 ;ADC Channel 14
   ADC14    = 0x10 ;AtoD Channel 14
   AIN14    = 0x10 ;Analog Input 14
   ADC_CH13 = 0x20 ;ADC Channel 13
   ACH13    = 0x20 ;ADC Channel 13
   ADC13    = 0x20 ;AtoD Channel 13
   AIN13    = 0x20 ;Analog Input 13
   ADC_CH12 = 0x40 ;ADC Channel 12
   ACH12    = 0x40 ;ADC Channel 12
   ADC12    = 0x40 ;AtoD Channel 12
   AIN12    = 0x40 ;Analog Input 12
   ADC_CH11 = 0x80 ;ADC Channel 11
   ACH11    = 0x80 ;ADC Channel 11
   ADC11    = 0x80 ;AtoD Channel 11
   AIN11    = 0x80 ;Analog Input 11
   P60  = 0x01 ;Port 6 Bit 0
   P61  = 0x02 ;Port 6 Bit 1
   P62  = 0x04 ;Port 6 Bit 2
   P63  = 0x08 ;Port 6 Bit 3
   P64  = 0x10 ;Port 6 Bit 4
   P65  = 0x20 ;Port 6 Bit 5
   P66  = 0x40 ;Port 6 Bit 6
   P67  = 0x80 ;Port 6 Bit 7
   P6_0 = 0x01 ;Port 6 Bit 0
   P6_1 = 0x02 ;Port 6 Bit 1
   P6_2 = 0x04 ;Port 6 Bit 2
   P6_3 = 0x08 ;Port 6 Bit 3
   P6_4 = 0x10 ;Port 6 Bit 4
   P6_5 = 0x20 ;Port 6 Bit 5
   P6_6 = 0x40 ;Port 6 Bit 6
   P6_7 = 0x80 ;Port 6 Bit 7
   ; See data sheet for additional pin names.
DMA3TSR .EQU 0xA9
DMA3BAH .EQU 0xAA
DMA3CR0 .EQU 0xAB
DMA3MAL .EQU 0xAC
DMA3CNT .EQU 0xAD
DMA3CCNT .EQU 0xAE
MTM3DAL .EQU 0xAF

DMA2TSR .EQU 0xB1
DMA2BAH .EQU 0xB2
DMA2CR0 .EQU 0xB3
DMA2MAL .EQU 0xB4
DMA2CNT .EQU 0xB5
DMA2CCNT .EQU 0xB6
MTM2DAL .EQU 0xB7
PWM2PH .EQU 0xB9
PWM2C0H .EQU 0xBA
PWM2C1H .EQU 0xBB
PWM2MD .EQU 0xBC
PWM2MEN .EQU 0xBD
CWKH .EQU 0xBE
RWKH .EQU 0xBF

PWM2PL .EQU 0xC1
PWM2C0L .EQU 0xC2
PWM2C1L .EQU 0xC3
PWM2CON0 .EQU 0xC4
PWM2CON1 .EQU 0xC5
PWM2INTC .EQU 0xC6
PWM3PH .EQU 0xC9
PWM3C0H .EQU 0xCA
PWM3C1H .EQU 0xCB
PWM3MD .EQU 0xCC
PWM3MEN .EQU 0xCD
AINDIDS1 .EQU 0xCE
I2C0ADDRM .EQU 0xCF

PWM3PL .EQU 0xD1
PWM3C0L .EQU 0xD2
PWM3C1L .EQU 0xD3
PWM3CON0 .EQU 0xD4
PWM3CON1 .EQU 0xD5
PWM3INTC .EQU 0xD6
I2C1ADDRM .EQU 0xD7
SC1DR .EQU 0xD9
SC1EGT .EQU 0xDA
SC1ETURD0 .EQU 0xDB
SC1ETURD1 .EQU 0xDC
SC1IE .EQU 0xDD
SC1IS .EQU 0xDE
SC1TSR .EQU 0xDF

P5MF32 .EQU 0xE1
P5MF54 .EQU 0xE2
P5MF76 .EQU 0xE3
BRCTRIM .EQU 0xE4
ADCCAL .EQU 0xE5
SC1CR0 .EQU 0xE6
SC1CR1 .EQU 0xE7
P3MF54 .EQU 0xE9
P3MF76 .EQU 0xEA
P4MF10 .EQU 0xEB
P4MF32 .EQU 0xEC
P4MF54 .EQU 0xED
P4MF76 .EQU 0xEE
P5MF10 .EQU 0xEF

P1MF76 .EQU 0xF1
P2MF10 .EQU 0xF2
P2MF32 .EQU 0xF3
P2MF54 .EQU 0xF4
P2MF76 .EQU 0xF5
P3MF10 .EQU 0xF6
P3MF32 .EQU 0xF7
P0MF10 .EQU 0xF9
P0MF32 .EQU 0xFA
P0MF54 .EQU 0xFB
P0MF76 .EQU 0xFC
P1MF10 .EQU 0xFD
P1MF32 .EQU 0xFE
P1MF54 .EQU 0xFF

;  ML56 SFR BYTE page 3

DMA0CR1 .EQU 0x8A
DMA1CR1 .EQU 0x8B
DMA2CR1 .EQU 0x8C
DMA3CR1 .EQU 0x8D

DMA0CRC .EQU 0x92
DMA1CRC .EQU 0x93
DMA2CRC .EQU 0x94
DMA3CRC .EQU 0x95
WDCONH .EQU 0x99
DMA0SEED .EQU 0x9A
DMA1SEED .EQU 0x9B
DMA2SEED .EQU 0x9C
DMA3SEED .EQU 0x9D

RTCINIT .EQU 0xA1
RTCRWEN .EQU 0xA2
RTCCLKSEL .EQU 0xA3
RTCFREQADJ0 .EQU 0xA4
RTCFREQADJ1 .EQU 0xA5
RTCINTEN .EQU 0xA6
RTCINTSTS .EQU 0xA7
RTCTIMESEC .EQU 0xA9
RTCTIMEMIN .EQU 0xAA
RTCTIMEHR .EQU 0xAB
RTCCALDAY .EQU 0xAD
RTCCALMON .EQU 0xAE
RTCCALYEAR .EQU 0xAF

RTCTALMSEC .EQU 0xB1
RTCTALMMIN .EQU 0xB2
RTCTALMHR .EQU 0xB3
RTCTALMHZ .EQU 0xB4
RTCCALMDAY .EQU 0xB5
RTCCALMMON .EQU 0xB6
RTCCALMYEAR .EQU 0xB7
RTCCLKFMT .EQU 0xB9
RTCWEEKDAY .EQU 0xBB
RTCLEAPYEAR .EQU 0xBC
RTCTICK .EQU 0xBD
RTCTAMSK .EQU 0xBE
RTCCAMSK .EQU 0xBF

PWM0FBS .EQU 0xCE
AUXR3 .EQU 0xCF

LCDCPALCT1 .EQU 0xE9
LCDCPCT1 .EQU 0xEA

LCDCPUMP .EQU 0xF1
LCDCON1 .EQU 0xF4
LCDCPALCT0 .EQU 0xF5
LCDCPCT0 .EQU 0xF6
LCDCON0 .EQU 0xF9
LCDCLK .EQU 0xFA
LCDPTR .EQU 0xFB
LCDDAT .EQU 0xFC
LCDPWR .EQU 0xFD
LCDBL .EQU 0xFE
LCDMODE .EQU 0xFF

;Interrupt numbers: Address = ( Number * 8 ) + 3
;Vectors are named after their corresponding interrupt
;enable register bit, so that we don't have to make up
;names and can be consisten across different 8051 MCUs
   X0_VECTOR   = 0  ; 0x03 External Interrupt 0
   T0_VECTOR   = 1  ; 0x0B Timer 0
   X1_VECTOR   = 2  ; 0x13 External Interrupt 1
   T1_VECTOR   = 3  ; 0x1B Timer 1
   S_VECTOR    = 4  ; 0x23 Serial Port 0
   T2_VECTOR   = 5  ; 0x2B Timer 2
   I2C0_VECTOR = 6  ; 0x33 Inter-Integrated Circuit 0
   PI_VECTOR   = 7  ; 0x3B Pin Interrupt
   BOD_VECTOR  = 8  ; 0x43 Brown-out
   SPI0_VECTOR = 9  ; 0x4B Serial Peripheral Interface 0
   WDT_VECTOR  = 10 ; 0x53 Watchdog timer
   ADC_VECTOR  = 11 ; 0x5B Analog Digital Converter
   CAP_VECTOR  = 12 ; 0x63 Input Capture
   PWM0_VECTOR = 13 ; 0x6B Pulse Width Modulator 0
   FB_VECTOR   = 14 ; 0x73 Fault Brake Event
   S1_VECTOR   = 15 ; 0x7B Serial Port 1
   T3_VECTOR   = 16 ; 0x83 Timer 3
   WKT_VECTOR  = 17 ; 0x8B Self Wake-up Timer
   HF_VECTOR   = 18 ; 0x93 CPU Hard Fault
   SMC0_VECTOR = 19 ; 0x9B Smart Card 0
   DMA0_VECTOR = 20 ; 0xA3 Direct Memory Access 0
   DMA1_VECTOR = 21 ; 0xAB Direct Memory Access 1
   SPI1_VECTOR = 22 ; 0xB3 Serial Peripheral Interface 1
   ACMP_VECTOR = 23 ; 0xBB Analog Comparator
   I2C1_VECTOR = 24 ; 0xC3 Inter-Integrated Circuit 1
   PWM_VECTOR  = 25 ; 0xCB Pulse Width Modulator 123
   TK_VECTOR   = 26 ; 0xD3 Touch Key
   SMC1_VECTOR = 27 ; 0xDB Smart Card 1
   DMA2_VECTOR = 28 ; 0xE3 Direct Memory Access 2
   DMA3_VECTOR = 29 ; 0xEB Direct Memory Access 3
   RTC_VECTOR  = 30 ; 0xF3 Real Time Clock

;.endif