; SDAS compatible header file MS51_32K.asm 20210823.
; For Nuvoton MS51_32K series.

;.ifndef MS51_32K_ASM
;.define MS51_32K_ASM

;  MS51_32K SFR BYTE page 0

P0 .EQU 0x80
   IC3_P00      .EQU 0x80+0 ;Input Capture 3
   MOSI         .EQU 0x80+0 ;Master Out Slave In
   OSCIN_10     .EQU 0x80+0 ;Oscillator In
   PWM0_CH3     .EQU 0x80+0 ;Pulse Width Modulator 0 Channel 3
   PWM2_CH1_10  .EQU 0x80+0 ;Pulse Width Modulator 2 Channel 1
   RXD_1_11     .EQU 0x80+0 ;Receive Data 1
   T1           .EQU 0x80+0 ;Timer 1
   IC4          .EQU 0x80+1 ;Input Capture 4
   MISO         .EQU 0x80+1 ;Master In Slave Out
   PWM0_CH4     .EQU 0x80+1 ;Pulse Width Modulator 0 Channel 4
   PWM3_CH0_10  .EQU 0x80+1 ;Pulse Width Modulator 3 Channel 0
   ICE_CLK      .EQU 0x80+2 ;In Circuit Emulator Clock
   RXD_1_01     .EQU 0x80+2 ;Receive Data 1
   SCL_P02      .EQU 0x80+2 ;Serial Clock
   ADC_CH6      .EQU 0x80+3 ;Analog Digital Converter Channel 6
   ACH6         .EQU 0x80+3 ;ADC Channel 6
   ADC6         .EQU 0x80+3 ;AtoD Channel 6
   AIN6         .EQU 0x80+3 ;Analog Input 6
   IC5          .EQU 0x80+3 ;Input Capture 5
   PWM0_CH5_P03 .EQU 0x80+3 ;Pulse Width Modulator 0 Channel 5
   PWM3_CH1_11  .EQU 0x80+3 ;Pulse Width Modulator 3 Channel 1
   SC0_CLK_01   .EQU 0x80+3 ;Smart Card 0 Clock
   TXD_2_01     .EQU 0x80+3 ;Transmit Data 2
   ADC_CH5      .EQU 0x80+4 ;Analog Digital Converter Channel 5
   ACH5         .EQU 0x80+4 ;ADC Channel 5
   ADC5         .EQU 0x80+4 ;AtoD Channel 5
   AIN5         .EQU 0x80+4 ;Analog Input 5
   IC3_P04      .EQU 0x80+4 ;Input Capture 3
   PWM0_CH3_P04 .EQU 0x80+4 ;Pulse Width Modulator 0 Channel 3
   PWM2_CH1_11  .EQU 0x80+4 ;Pulse Width Modulator 2 Channel 1
   RXD_2_01     .EQU 0x80+4 ;Receive Data 2
   SC0_DAT_01   .EQU 0x80+4 ;Smart Card 0 Data
   STADC        .EQU 0x80+4 ;Start Analog to Digital Conversion
   ADC_CH4      .EQU 0x80+5 ;Analog Digital Converter Channel 4
   ACH4         .EQU 0x80+5 ;ADC Channel 4
   ADC4         .EQU 0x80+5 ;AtoD Channel 4
   AIN4         .EQU 0x80+5 ;Analog Input 4
   IC6          .EQU 0x80+5 ;Input Capture 6
   PWM0_CH2_P05 .EQU 0x80+5 ;Pulse Width Modulator 0 Channel 2
   PWM2_CH0_11  .EQU 0x80+5 ;Pulse Width Modulator 2 Channel 0
   SC1_CLK_11   .EQU 0x80+5 ;Smart Card 1 Clock
   T0           .EQU 0x80+5 ;Timer 0
   TXD_3_11     .EQU 0x80+5 ;Transmit Data 3
   ADC_CH3      .EQU 0x80+6 ;Analog Digital Converter Channel 3
   ACH3         .EQU 0x80+6 ;ADC Channel 3
   ADC3         .EQU 0x80+6 ;AtoD Channel 3
   AIN3         .EQU 0x80+6 ;Analog Input 3
   RXD_P06      .EQU 0x80+6 ;Receive Data
   TXD          .EQU 0x80+6 ;Transmit Data
   ADC_CH2      .EQU 0x80+7 ;Analog Digital Converter Channel 2
   ACH2         .EQU 0x80+7 ;ADC Channel 2
   ADC2         .EQU 0x80+7 ;AtoD Channel 2
   AIN2         .EQU 0x80+7 ;Analog Input 2
   RXD          .EQU 0x80+7 ;Receive Data
   TXD_P07      .EQU 0x80+7 ;Transmit Data
   P00 .EQU 0x80+0 ;Port 0 Bit 0
   P01 .EQU 0x80+1 ;Port 0 Bit 1
   P02 .EQU 0x80+2 ;Port 0 Bit 2
   P03 .EQU 0x80+3 ;Port 0 Bit 3
   P04 .EQU 0x80+4 ;Port 0 Bit 4
   P05 .EQU 0x80+5 ;Port 0 Bit 5
   P06 .EQU 0x80+6 ;Port 0 Bit 6
   P07 .EQU 0x80+7 ;Port 0 Bit 7
   P0_0 .EQU 0x80+0 ;Port 0 Bit 0
   P0_1 .EQU 0x80+1 ;Port 0 Bit 1
   P0_2 .EQU 0x80+2 ;Port 0 Bit 2
   P0_3 .EQU 0x80+3 ;Port 0 Bit 3
   P0_4 .EQU 0x80+4 ;Port 0 Bit 4
   P0_5 .EQU 0x80+5 ;Port 0 Bit 5
   P0_6 .EQU 0x80+6 ;Port 0 Bit 6
   P0_7 .EQU 0x80+7 ;Port 0 Bit 7
SP .EQU 0x81
;DPTR .EQU 0x82
DPL .EQU 0x82
DPH .EQU 0x83
RCTRIM0 .EQU 0x84
RCTRIM1 .EQU 0x85
RWKL .EQU 0x86
PCON .EQU 0x87
TCON .EQU 0x88
   IT0 .EQU 0x88+0 ;Interrupt 0 Type
   IE0 .EQU 0x88+1 ;Interrupt 0 Edge
   IT1 .EQU 0x88+2 ;Interrupt 1 Type
   IE1 .EQU 0x88+3 ;Interrupt 1 Edge
   TR0 .EQU 0x88+4 ;Timer 0 Run
   TF0 .EQU 0x88+5 ;Timer 0 Flag
   TR1 .EQU 0x88+6 ;Timer 1 Run
   TF1 .EQU 0x88+7 ;Timer 1 Flag
TMOD .EQU 0x89
TL0 .EQU 0x8A
TL1 .EQU 0x8B
TH0 .EQU 0x8C
TH1 .EQU 0x8D
CKCON .EQU 0x8E
WKCON .EQU 0x8F
P1 .EQU 0x90
   IC2            .EQU 0x90+0 ;Input Capture 2
   PWM0_CH2_P10   .EQU 0x90+0 ;Pulse Width Modulator 0 Channel 2
   PWM2_CH0_10    .EQU 0x90+0 ;Pulse Width Modulator 2 Channel 0
   SPCLK          .EQU 0x90+0 ;Serial Peripheral Clock
   TXD_1_11       .EQU 0x90+0 ;Transmit Data 1
   ADC_CH7        .EQU 0x90+1 ;Analog Digital Converter Channel 7
   ACH7           .EQU 0x90+1 ;ADC Channel 7
   ADC7           .EQU 0x90+1 ;AtoD Channel 7
   AIN7           .EQU 0x90+1 ;Analog Input 7
   CLKO           .EQU 0x90+1 ;Clock Out
   IC1            .EQU 0x90+1 ;Input Capture 1
   PWM0_CH1_P11   .EQU 0x90+1 ;Pulse Width Modulator 0 Channel 1
   PWM1_CH1_11    .EQU 0x90+1 ;Pulse Width Modulator 1 Channel 1
   RXD_3_01       .EQU 0x90+1 ;Receive Data 3
   SC1_DAT_01     .EQU 0x90+1 ;Smart Card 1 Data
   IC0            .EQU 0x90+2 ;Input Capture 0
   PWM0_CH0       .EQU 0x90+2 ;Pulse Width Modulator 0 Channel 0
   PWM1_CH0_10    .EQU 0x90+2 ;Pulse Width Modulator 1 Channel 0
   SC1_CLK_01     .EQU 0x90+2 ;Smart Card 1 Clock
   TXD_3_01       .EQU 0x90+2 ;Transmit Data 3
   ADC_CH13       .EQU 0x90+3 ;Analog Digital Converter Channel 13
   ACH13          .EQU 0x90+3 ;ADC Channel 13
   ADC13          .EQU 0x90+3 ;AtoD Channel 13
   AIN13          .EQU 0x90+3 ;Analog Input 13
   SCL            .EQU 0x90+3 ;Serial Clock
   STADC_P13      .EQU 0x90+3 ;Start Analog to Digital Conversion
   ADC_CH14       .EQU 0x90+4 ;Analog Digital Converter Channel 14
   ACH14          .EQU 0x90+4 ;ADC Channel 14
   ADC14          .EQU 0x90+4 ;AtoD Channel 14
   AIN14          .EQU 0x90+4 ;Analog Input 14
   PWM0_BRAKE_P14 .EQU 0x90+4 ;Pulse Width Modulator 0 Brake
   PWM0_CH1_P14   .EQU 0x90+4 ;Pulse Width Modulator 0 Channel 1
   PWM1_CH1_10    .EQU 0x90+4 ;Pulse Width Modulator 1 Channel 1
   SDA            .EQU 0x90+4 ;Serial Data
   IC7            .EQU 0x90+5 ;Input Capture 7
   PWM0_CH5_P15   .EQU 0x90+5 ;Pulse Width Modulator 0 Channel 5
   PWM3_CH1_10    .EQU 0x90+5 ;Pulse Width Modulator 3 Channel 1
   SC1_CLK_10     .EQU 0x90+5 ;Smart Card 1 Clock
   SS             .EQU 0x90+5 ;Slave Select
   TXD_3_10       .EQU 0x90+5 ;Transmit Data 3
   ICE_DAT        .EQU 0x90+6 ;In Circuit Emulator Data
   SDA_P16        .EQU 0x90+6 ;Serial Data
   TXD_1_01       .EQU 0x90+6 ;Transmit Data 1
   ADC_CH0        .EQU 0x90+7 ;Analog Digital Converter Channel 0
   ACH0           .EQU 0x90+7 ;ADC Channel 0
   ADC0           .EQU 0x90+7 ;AtoD Channel 0
   AIN0           .EQU 0x90+7 ;Analog Input 0
   INT1           .EQU 0x90+7 ;Interrupt 1
   PWM3_CH0       .EQU 0x90+7 ;Pulse Width Modulator 3 Channel 0
   RXD_2_10       .EQU 0x90+7 ;Receive Data 2
   SC0_DAT_10     .EQU 0x90+7 ;Smart Card 0 Data
   SPCLK_P17      .EQU 0x90+7 ;Serial Peripheral Clock
   P10  .EQU 0x90+0 ;Port 1 Bit 0
   P11  .EQU 0x90+1 ;Port 1 Bit 1
   P12  .EQU 0x90+2 ;Port 1 Bit 2
   P13  .EQU 0x90+3 ;Port 1 Bit 3
   P14  .EQU 0x90+4 ;Port 1 Bit 4
   P15  .EQU 0x90+5 ;Port 1 Bit 5
   P16  .EQU 0x90+6 ;Port 1 Bit 6
   P17  .EQU 0x90+7 ;Port 1 Bit 7
   P1_0 .EQU 0x90+0 ;Port 1 Bit 0
   P1_1 .EQU 0x90+1 ;Port 1 Bit 1
   P1_2 .EQU 0x90+2 ;Port 1 Bit 2
   P1_3 .EQU 0x90+3 ;Port 1 Bit 3
   P1_4 .EQU 0x90+4 ;Port 1 Bit 4
   P1_5 .EQU 0x90+5 ;Port 1 Bit 5
   P1_6 .EQU 0x90+6 ;Port 1 Bit 6
   P1_7 .EQU 0x90+7 ;Port 1 Bit 7
SFRS .EQU 0x91
CAPCON0 .EQU 0x92
CAPCON1 .EQU 0x93
CAPCON2 .EQU 0x94
CKDIV .EQU 0x95
CKSWT .EQU 0x96
CKEN .EQU 0x97
SCON .EQU 0x98
   RI  .EQU 0x98+0 ;Receive Interrupt
   TI  .EQU 0x98+1 ;Transmit Interrupt
   RB8 .EQU 0x98+2 ;Receive Bit 8
   TB8 .EQU 0x98+3 ;Transmit Bit 8
   REN .EQU 0x98+4 ;Receive Enable
   SM2 .EQU 0x98+5 ;Serial Mode 2
   SM1 .EQU 0x98+6 ;Serial Mode 1
   SM0 .EQU 0x98+7 ;Serial Mode 0
   FE  .EQU 0x98+7 ;Framing Error
SBUF .EQU 0x99
SBUF_1 .EQU 0x9A
EIE .EQU 0x9B
EIE1 .EQU 0x9C
CHPCON .EQU 0x9F
P2 .EQU 0xA0
   NRESET      .EQU 0xA0+0 ;Reset
   RST         .EQU 0xA0+0 ;Reset
   ADC_CH9     .EQU 0xA0+1 ;Analog Digital Converter Channel 9
   ACH9        .EQU 0xA0+1 ;ADC Channel 9
   ADC9        .EQU 0xA0+1 ;AtoD Channel 9
   AIN9        .EQU 0xA0+1 ;Analog Input 9
   PWM2_CH0_01 .EQU 0xA0+1 ;Pulse Width Modulator 2 Channel 0
   ADC_CH10    .EQU 0xA0+2 ;Analog Digital Converter Channel 10
   ACH10       .EQU 0xA0+2 ;ADC Channel 10
   ADC10       .EQU 0xA0+2 ;AtoD Channel 10
   AIN10       .EQU 0xA0+2 ;Analog Input 10
   PWM1_CH1_01 .EQU 0xA0+2 ;Pulse Width Modulator 1 Channel 1
   RXD_4_01    .EQU 0xA0+2 ;Receive Data UART-4
   SC2_DAT_01  .EQU 0xA0+2 ;Smart Card 2 Data
   ADC_CH11    .EQU 0xA0+2 ;Analog Digital Converter Channel 11
   ACH11       .EQU 0xA0+2 ;ADC Channel 11
   ADC11       .EQU 0xA0+2 ;AtoD Channel 11
   AIN11       .EQU 0xA0+2 ;Analog Input 11
   PWM1_CH0_01 .EQU 0xA0+3 ;Pulse Width Modulator 1 Channel 0
   SC2_CLK_01  .EQU 0xA0+3 ;Smart Card 2 Clock
   TXD_4_01    .EQU 0xA0+3 ;Transmit Data UART-4
   ADC_CH12    .EQU 0xA0+3 ;Analog Digital Converter Channel 12
   ACH12       .EQU 0xA0+3 ;ADC Channel 12
   ADC12       .EQU 0xA0+3 ;AtoD Channel 12
   AIN12       .EQU 0xA0+3 ;Analog Input 12
   T0_P24      .EQU 0xA0+4 ;Timer 0
   ADC_CH15    .EQU 0xA0+5 ;Analog Digital Converter Channel 15
   ACH15       .EQU 0xA0+5 ;ADC Channel 15
   ADC15       .EQU 0xA0+5 ;AtoD Channel 15
   AIN15       .EQU 0xA0+5 ;Analog Input 15
   MISO_P25    .EQU 0xA0+5 ;Master In Slave Out
   RXD_3_10    .EQU 0xA0+5 ;Receive Data UART-3
   SC1_DAT_10  .EQU 0xA0+5 ;Smart Card 1 Data
   P20  .EQU 0xA0+0 ;Port 0 Bit 0
   P21  .EQU 0xA0+1 ;Port 2 Bit 1
   P22  .EQU 0xA0+2 ;Port 2 Bit 2
   P23  .EQU 0xA0+3 ;Port 2 Bit 3
   P24  .EQU 0xA0+4 ;Port 2 Bit 4
   P25  .EQU 0xA0+5 ;Port 2 Bit 5
   P2_0 .EQU 0xA0+0 ;Port 2 Bit 0
   P2_1 .EQU 0xA0+1 ;Port 2 Bit 1
   P2_2 .EQU 0xA0+2 ;Port 2 Bit 2
   P2_3 .EQU 0xA0+3 ;Port 2 Bit 3
   P2_4 .EQU 0xA0+4 ;Port 2 Bit 4
   P2_5 .EQU 0xA0+5 ;Port 2 Bit 5
AUXR1 .EQU 0xA2
BODCON0 .EQU 0xA3
IAPTRG .EQU 0xA4
IAPUEN .EQU 0xA5
IAPAL .EQU 0xA6
IAPAH .EQU 0xA7
IE .EQU 0xA8
   EX0  .EQU 0xA8+0 ;Enable External 0
   ET0  .EQU 0xA8+1 ;Enable Timer 0
   EX1  .EQU 0xA8+2 ;Enable External 1
   ET1  .EQU 0xA8+3 ;Enable Timer 1
   ES   .EQU 0xA8+4 ;Enable Serial
   EBOD .EQU 0xA8+5 ;Enable Brown Out Detection
   EADC .EQU 0xA8+6 ;Enable Analog Digital Converter
   EA   .EQU 0xA8+7 ;Enable All
SADDR .EQU 0xA9
WDCON .EQU 0xAA
BODCON1 .EQU 0xAB
P3M1 .EQU 0xAC
P3M2 .EQU 0xAD
IAPFD .EQU 0xAE
IAPCN .EQU 0xAF
P3 .EQU 0xB0
   ADC_CH1        .EQU 0xB0+0 ;Analog Digital Converter Channel 1
   ACH1           .EQU 0xB0+0 ;ADC Channel 1
   ADC1           .EQU 0xB0+0 ;AtoD Channel 1
   AIN1           .EQU 0xB0+0 ;Analog Input 1
   INT0           .EQU 0xB0+0 ;Interrupt 0
   MOSI_P30       .EQU 0xB0+0 ;Master In Slave Out
   PWM2_CH1       .EQU 0xB0+0 ;Pulse Width Modulator 2 Channel 1
   SC0_CLK_10     .EQU 0xB0+0 ;Smart Card 0 Clock
   TXD_2_10       .EQU 0xB0+0 ;Transmit Data UART-2
   OSCIN_11       .EQU 0xB0+0 ;Oscillator In
   PWM2_CH1_01    .EQU 0xB0+1 ;Pulse Width Modulator 2 Channel 1
   PWM3_CH0_01    .EQU 0xB0+2 ;Pulse Width Modulator 3 Channel 0
   PWM0_BRAKE_P33 .EQU 0xB0+3 ;Pulse Width Modulator 0 Brake
   CLO_P33        .EQU 0xB0+3 ;Clock Out
   PWM3_CH1_01    .EQU 0xB0+4 ;Pulse Width Modulator 3 Channel 1
   RXD_3_11       .EQU 0xB0+4 ;Receive Data UART-3
   SC1_DAT_11     .EQU 0xB0+4 ;Smart Card 1 Data
   SS_P_35        .EQU 0xB0+5 ;Slave Select
   TXD_1_10       .EQU 0xB0+6 ;Transmit Data UART-1
   RXD_1_10       .EQU 0xB0+7 ;Receive Data UART-1
   P30  .EQU 0xB0+0 ;Port 3 Bit 0
   P31  .EQU 0xB0+1 ;Port 3 Bit 1
   P32  .EQU 0xB0+2 ;Port 3 Bit 2
   P33  .EQU 0xB0+3 ;Port 3 Bit 3
   P34  .EQU 0xB0+4 ;Port 3 Bit 4
   P35  .EQU 0xB0+5 ;Port 3 Bit 5
   P36  .EQU 0xB0+6 ;Port 3 Bit 6
   P37  .EQU 0xB0+7 ;Port 3 Bit 7
   P3_0 .EQU 0xB0+0 ;Port 3 Bit 0
   P3_1 .EQU 0xB0+1 ;Port 3 Bit 1
   P3_2 .EQU 0xB0+2 ;Port 3 Bit 2
   P3_3 .EQU 0xB0+3 ;Port 3 Bit 3
   P3_4 .EQU 0xB0+4 ;Port 3 Bit 4
   P3_5 .EQU 0xB0+5 ;Port 3 Bit 5
   P3_6 .EQU 0xB0+6 ;Port 3 Bit 6
   P3_7 .EQU 0xB0+7 ;Port 3 Bit 7
P0M1 .EQU 0xB1
P0M2 .EQU 0xB2
P1M1 .EQU 0xB3
P1M2 .EQU 0xB4
TOE .EQU 0xB5
IPH .EQU 0xB7
IP .EQU 0xB8
   PX0  .EQU 0xB8+0 ;Priority External 0
   PT0  .EQU 0xB8+1 ;Priority Timer 0
   PX1  .EQU 0xB8+2 ;Priority External 1
   PT1  .EQU 0xB8+3 ;Priority Timer 1
   PS   .EQU 0xB8+4 ;Priority Serial
   PBOD .EQU 0xB8+5 ;Priority Brown Out Detection
   PADC .EQU 0xB8+6 ;Priority Analog Digital Converter
SADEN .EQU 0xB9
SADEN_1 .EQU 0xBA
SADDR_1 .EQU 0xBB
I2DAT .EQU 0xBC
I2STAT .EQU 0xBD
I2CLK .EQU 0xBE
I2TOC .EQU 0xBF
I2CON .EQU 0xC0
   I2CPX .EQU 0xC0+0 ;Inter-Integrated Circuit Pin eXchange
   AA    .EQU 0xC0+2 ;Acknowledge Assert
   SI    .EQU 0xC0+3 ;Status Interrupt
   STO   .EQU 0xC0+4 ;Stop
   STA   .EQU 0xC0+5 ;Start
   I2CEN .EQU 0xC0+6 ;Inter-Integrated Circuit Enable
   I     .EQU 0xC0+7 ;Increase
I2ADDR .EQU 0xC1
ADCRL .EQU 0xC2
ADCRH .EQU 0xC3
T3CON .EQU 0xC4
RL3 .EQU 0xC5
RH3 .EQU 0xC6
TA .EQU 0xC7
T2CON .EQU 0xC8
   CM_RL2 .EQU 0xC8+0 ;Compare Reload 2
   TR2    .EQU 0xC8+2 ;Timer 2 Run
   TF2    .EQU 0xC8+7 ;Timer 2 Flag
T2MOD .EQU 0xC9
RCMP2L .EQU 0xCA
RCMP2H .EQU 0xCB
TL2 .EQU 0xCC
TH2 .EQU 0xCD
ADCMPL .EQU 0xCE
ADCMPH .EQU 0xCF
PSW .EQU 0xD0
   P   .EQU 0xD0+0 ;Parity
   F1  .EQU 0xD0+1 ;Flag 1
   OV  .EQU 0xD0+2 ;Overflow
   RS0 .EQU 0xD0+3 ;Register Select 0
   RS1 .EQU 0xD0+4 ;Register Select 1
   F0  .EQU 0xD0+5 ;Flag 0
   AC  .EQU 0xD0+6 ;Auxiliary Carry
   CY  .EQU 0xD0+7 ;Carry
PWM0PH .EQU 0xD1
PWM0C0H .EQU 0xD2
PWM0C1H .EQU 0xD3
PWM0C2H .EQU 0xD4
PWM0C3H .EQU 0xD5
PNP .EQU 0xD6
PWM0FBD .EQU 0xD7
PWM0CON0 .EQU 0xD8
   CLRPWM .EQU 0xD8+4 ;Clear Pulse Width Modulator
   PWMF   .EQU 0xD8+5 ;Pusle Width Modulator Flan
   LOAD   .EQU 0xD8+6 ;Load
   PWMRUN .EQU 0xD8+7 ;Pusle Width Modulator Run
PWM0PL .EQU 0xD9
PWM0C0L .EQU 0xDA
PWM0C1L .EQU 0xDB
PWM0C2L .EQU 0xDC
PWM0C3L .EQU 0xDD
PIOCON0 .EQU 0xDE
PWM0CON1 .EQU 0xDF
ACC .EQU 0xE0
   ACC0 .EQU 0xE0+0 ;Accumulator Bit 0
   ACC1 .EQU 0xE0+1 ;Accumulator Bit 1
   ACC2 .EQU 0xE0+2 ;Accumulator Bit 2
   ACC3 .EQU 0xE0+3 ;Accumulator Bit 3
   ACC4 .EQU 0xE0+4 ;Accumulator Bit 4
   ACC5 .EQU 0xE0+5 ;Accumulator Bit 5
   ACC6 .EQU 0xE0+6 ;Accumulator Bit 6
   ACC7 .EQU 0xE0+7 ;Accumulator Bit 7
   ACC_0 .EQU 0xE0+0 ;Accumulator Bit 0
   ACC_1 .EQU 0xE0+1 ;Accumulator Bit 1
   ACC_2 .EQU 0xE0+2 ;Accumulator Bit 2
   ACC_3 .EQU 0xE0+3 ;Accumulator Bit 3
   ACC_4 .EQU 0xE0+4 ;Accumulator Bit 4
   ACC_5 .EQU 0xE0+5 ;Accumulator Bit 5
   ACC_6 .EQU 0xE0+6 ;Accumulator Bit 6
   ACC_7 .EQU 0xE0+7 ;Accumulator Bit 7
ADCCON1 .EQU 0xE1
ADCCON2 .EQU 0xE2
ADCDLY .EQU 0xE3
C0L .EQU 0xE4
C0H .EQU 0xE5
C1L .EQU 0xE6
C1H .EQU 0xE7
ADCCON0 .EQU 0xE8
   ADCHS0  .EQU 0xE8+0 ;Analog Digital Channel Select 0
   ADCHS1  .EQU 0xE8+1 ;Analog Digital Channel Select 1
   ADCHS2  .EQU 0xE8+2 ;Analog Digital Channel Select 2
   ADCHS3  .EQU 0xE8+3 ;Analog Digital Channel Select 3
   ETGSEL0 .EQU 0xE8+4 ;External Trigger Select 0
   ETGSEL1 .EQU 0xE8+5 ;External Trigger Select 1
   ADCS    .EQU 0xE8+6 ;Analog Digital Converter Start
   ADCF    .EQU 0xE8+7 ;Analog Digital Converter Flag
PICON .EQU 0xE9
PINEN .EQU 0xEA
PIPEN .EQU 0xEB
PIF .EQU 0xEC
C2L .EQU 0xED
C2H .EQU 0xEE
EIP .EQU 0xEF
B .EQU 0xF0
   B0 .EQU 0xF0+0 ;B Bit 0
   B1 .EQU 0xF0+1 ;B Bit 1
   B2 .EQU 0xF0+2 ;B Bit 2
   B3 .EQU 0xF0+3 ;B Bit 3
   B4 .EQU 0xF0+4 ;B Bit 4
   B5 .EQU 0xF0+5 ;B Bit 5
   B6 .EQU 0xF0+6 ;B Bit 6
   B7 .EQU 0xF0+7 ;B Bit 7
   B_0 .EQU 0xF0+0 ;B Bit 0
   B_1 .EQU 0xF0+1 ;B Bit 1
   B_2 .EQU 0xF0+2 ;B Bit 2
   B_3 .EQU 0xF0+3 ;B Bit 3
   B_4 .EQU 0xF0+4 ;B Bit 4
   B_5 .EQU 0xF0+5 ;B Bit 5
   B_6 .EQU 0xF0+6 ;B Bit 6
   B_7 .EQU 0xF0+7 ;B Bit 7
CAPCON3 .EQU 0xF1
CAPCON4 .EQU 0xF2
SPCR .EQU 0xF3
SPSR .EQU 0xF4
SPDR .EQU 0xF5
AINDIDS0 .EQU 0xF6
EIPH .EQU 0xF7
SCON_1 .EQU 0xF8
   RI_1  .EQU 0xF8+0 ;Receive Interrupt UART-1
   TI_1  .EQU 0xF8+1 ;Transmit Interrupt UART-1
   RB8_1 .EQU 0xF8+2 ;Receive Bit 8 UART-1
   TB8_1 .EQU 0xF8+3 ;Transmit Bit 8 UART-1
   REN_1 .EQU 0xF8+4 ;Receive Enable UART-1
   SM2_1 .EQU 0xF8+5 ;Serial Mode 2 UART-1
   SM1_1 .EQU 0xF8+6 ;Serial Mode 1 UART-1
   SM0_1 .EQU 0xF8+7 ;Serial Mode 0 UART-1
   FE_1  .EQU 0xF8+7 ;Framing Error UART-1
PWM0DTEN .EQU 0xF9
PWM0DTCNT .EQU 0xFA
PWM0MEN .EQU 0xFB
PWM0MD .EQU 0xFC
PORDIS .EQU 0xFD
EIP1 .EQU 0xFE
EIPH1 .EQU 0xFF

;  MS51_32K SFR BYTE page 1

P3S .EQU 0xAC
P3SR .EQU 0xAD

P0S .EQU 0xB1
P0SR .EQU 0xB2
P1S .EQU 0xB3
P1SR .EQU 0xB4
PWM0INTC .EQU 0xB7

PWM0C4H .EQU 0xC4
PWM0C5H .EQU 0xC5
PIOCON1 .EQU 0xC6
PWM0C4L .EQU 0xCC
PWM0C5L .EQU 0xCD

SPCR2 .EQU 0xF3

LVRDIS .EQU 0xFF

;  MS51_32K SFR BYTE page 2

ADCBAL .EQU 0x84
ADCBAH .EQU 0x85
ADCCON3 .EQU 0x86
P2M1 .EQU 0x89
P2M2 .EQU 0x8A
P2SR .EQU 0x8B
P2S .EQU 0x8C
ADCSN .EQU 0x8D
ADCCN .EQU 0x8E
ADCSR .EQU 0x8F

P0UP .EQU 0x92
P1UP .EQU 0x93
P2UP .EQU 0x94
P3UP .EQU 0x95
RWKH .EQU 0x97
AINDIDS1 .EQU 0x99
P0DW .EQU 0x9A
P1DW .EQU 0x9B
P2DW .EQU 0x9C
P3DW .EQU 0x9D

AUXR2 .EQU 0xA1
AUXR3 .EQU 0xA2
AUXR4 .EQU 0xA3
AUXR5 .EQU 0xA4
AUXR6 .EQU 0xA5
AUXR7 .EQU 0xA6
AUXR8 .EQU 0xA7
PWM1PH .EQU 0xA9
PWM1C0H .EQU 0xAA
PWM1C1H .EQU 0xAB
PWM1MD .EQU 0xAC
PWM1MEN .EQU 0xAD

PWM1PL .EQU 0xB1
PWM1C0L .EQU 0xB2
PWM1C1L .EQU 0xB3
PWM1CON0 .EQU 0xB4
PWM1CON1 .EQU 0xB5
PWM1INTC .EQU 0xB6
PIOCON2 .EQU 0xB7
PWM2PH .EQU 0xB9
PWM2C0H .EQU 0xBA
PWM2C1H .EQU 0xBB
PWM2MD .EQU 0xBC
PWM2MEN .EQU 0xBD

PWM2PL .EQU 0xC1
PWM2C0L .EQU 0xC2
PWM2C1L .EQU 0xC3
PWM2CON0 .EQU 0xC4
PWM2CON1 .EQU 0xC5
PWM2INTC .EQU 0xC6
PWM3PH .EQU 0xC9
PWM3C0H .EQU 0xCA
PWM3C1H .EQU 0xCB
PWM3MD .EQU 0xCC
PWM3MEN .EQU 0xCD
EIP2 .EQU 0xCE
EIPH2 .EQU 0xCF

PWM3PL .EQU 0xD1
PWM3C0L .EQU 0xD2
PWM3C1L .EQU 0xD3
PWM3CON0 .EQU 0xD4
PWM3CON1 .EQU 0xD5
PWM3INTC .EQU 0xD6
XTLCON .EQU 0xD7
SC0DR .EQU 0xD9
SC0EGT .EQU 0xDA
SC0ETURD0 .EQU 0xDB
SC0ETURD1 .EQU 0xDC
SC0IE .EQU 0xDD
SC0IS .EQU 0xDE
SC0TSR .EQU 0xDF

SC1DR .EQU 0xE1
SC1EGT .EQU 0xE2
SC1ETURD0 .EQU 0xE3
SC1ETURD1 .EQU 0xE4
SC1IE .EQU 0xE5
SC1IS .EQU 0xE6
SC1TSR .EQU 0xE7
SC2DR .EQU 0xE9
SC2EGT .EQU 0xEA
SC2ETURD0 .EQU 0xEB
SC2ETURD1 .EQU 0xEC
SC2IE .EQU 0xED
SC2IS .EQU 0xEE
SC2TSR .EQU 0xEF

SC0CR0 .EQU 0xF1
SC0CR1 .EQU 0xF2
SC1CR0 .EQU 0xF3
SC1CR1 .EQU 0xF4
SC2CR0 .EQU 0xF5
SC2CR1 .EQU 0xF6
PIPS7 .EQU 0xF7
PIPS0 .EQU 0xF9
PIPS1 .EQU 0xFA
PIPS2 .EQU 0xFB
PIPS3 .EQU 0xFC
PIPS4 .EQU 0xFD
PIPS5 .EQU 0xFE
PIPS6 .EQU 0xFF

;Interrupt numbers: Address = ( Number * 8 ) + 3
;Vectors are named after their corresponding interrupt
;enable register bit, so that we don't have to make up
;names and can be consisten across different 8051 MCUs
   X0_VECTOR   = 0  ; 0x03 External Interrupt 0
   T0_VECTOR   = 1  ; 0x0B Timer 0
   X1_VECTOR   = 2  ; 0x13 External Interrupt 1
   T1_VECTOR   = 3  ; 0x1B Timer 1
   S_VECTOR    = 4  ; 0x23 Serial Port 0
   T2_VECTOR   = 5  ; 0x2B Timer 2
   I2C_VECTOR  = 6  ; 0x33 Inter-Integrated Circuit
   PI_VECTOR   = 7  ; 0x3B Pin Interrupt
   BOD_VECTOR  = 8  ; 0x43 Brown-out
   SPI_VECTOR  = 9  ; 0x4B Serial Peripheral Interface
   WDT_VECTOR  = 10 ; 0x53 Watchdog timer
   ADC_VECTOR  = 11 ; 0x5B Analog Digital Converter
   CAP_VECTOR  = 12 ; 0x63 Input Capture
   PWM0_VECTOR = 13 ; 0x6B Pulse Width Modulator 0
   FB_VECTOR   = 14 ; 0x73 Fault Brake Event
   S1_VECTOR   = 15 ; 0x7B Serial Port 1
   T3_VECTOR   = 16 ; 0x83 Timer 3
   WKT_VECTOR  = 17 ; 0x8B Self Wake-up Timer
   PWM1_VECTOR = 18 ; 0x93 Pulse Width Modulator 1
   PWM2_VECTOR = 19 ; 0x9B Pulse Width Modulator 2
   PWM3_VECTOR = 20 ; 0xA3 Pulse Width Modulator 3
   SC0_VECTOR  = 21 ; 0xAB Smart Card 0
   SC1_VECTOR  = 22 ; 0xB3 Smart Card 1
   SC2_VECTOR  = 23 ; 0xBB Smart Card 2

;.endif