; SDAS compatible header file N79E875.asm 20210823.
; For Nuvoton N79E875.

;.ifndef N79E875_ASM
;.define N79E875_ASM

P0 .EQU 0x80
   P00 .EQU 0x80+0 ;Port 0 Bit 0
   P01 .EQU 0x80+1 ;Port 0 Bit 1
   P02 .EQU 0x80+2 ;Port 0 Bit 2
   P03 .EQU 0x80+3 ;Port 0 Bit 3
   P04 .EQU 0x80+4 ;Port 0 Bit 4
   P05 .EQU 0x80+5 ;Port 0 Bit 5
   P06 .EQU 0x80+6 ;Port 0 Bit 6
   P07 .EQU 0x80+7 ;Port 0 Bit 7
   P0_0 .EQU 0x80+0 ;Port 0 Bit 0
   P0_1 .EQU 0x80+1 ;Port 0 Bit 1
   P0_2 .EQU 0x80+2 ;Port 0 Bit 2
   P0_3 .EQU 0x80+3 ;Port 0 Bit 3
   P0_4 .EQU 0x80+4 ;Port 0 Bit 4
   P0_5 .EQU 0x80+5 ;Port 0 Bit 5
   P0_6 .EQU 0x80+6 ;Port 0 Bit 6
   P0_7 .EQU 0x80+7 ;Port 0 Bit 7
SP .EQU 0x81
;DPTR .EQU 0x82
DPL .EQU 0x82
DPH .EQU 0x83
sfrDIV .EQU 0x86
PCON .EQU 0x87
TCON .EQU 0x88
   IT0 .EQU 0x88+0 ;Interrupt 0 Type
   IE0 .EQU 0x88+1 ;Interrupt 0 Edge
   IT1 .EQU 0x88+2 ;Interrupt 1 Type
   IE1 .EQU 0x88+3 ;Interrupt 1 Edge
   TR0 .EQU 0x88+4 ;Timer 0 Run
   TF0 .EQU 0x88+5 ;Timer 0 Flag
   TR1 .EQU 0x88+6 ;Timer 1 Run
   TF1 .EQU 0x88+7 ;Timer 1 Flag
TMOD .EQU 0x89
TL0 .EQU 0x8A
TL1 .EQU 0x8B
TH0 .EQU 0x8C
TH1 .EQU 0x8D
CKCON .EQU 0x8E
P1 .EQU 0x90
   P10 .EQU 0x90+0 ;Port 1 Bit 0
   P11 .EQU 0x90+1 ;Port 1 Bit 1
   P12 .EQU 0x90+2 ;Port 1 Bit 2
   P13 .EQU 0x90+3 ;Port 1 Bit 3
   P14 .EQU 0x90+4 ;Port 1 Bit 4
   P15 .EQU 0x90+5 ;Port 1 Bit 5
   P16 .EQU 0x90+6 ;Port 1 Bit 6
   P17 .EQU 0x90+7 ;Port 1 Bit 7
   P1_0 .EQU 0x90+0 ;Port 1 Bit 0
   P1_1 .EQU 0x90+1 ;Port 1 Bit 1
   P1_2 .EQU 0x90+2 ;Port 1 Bit 2
   P1_3 .EQU 0x90+3 ;Port 1 Bit 3
   P1_4 .EQU 0x90+4 ;Port 1 Bit 4
   P1_5 .EQU 0x90+5 ;Port 1 Bit 5
   P1_6 .EQU 0x90+6 ;Port 1 Bit 6
   P1_7 .EQU 0x90+7 ;Port 1 Bit 7
TL3 .EQU 0x91
RCAP3L .EQU 0x92
RCAP3HT3H .EQU 0x93
PWM4L .EQU 0x96
PWM4H .EQU 0x97
SCON .EQU 0x98
   RI  .EQU 0x98+0 ;Receive Interrupt
   TI  .EQU 0x98+1 ;Transmit Interrupt
   RB8 .EQU 0x98+2 ;Receive Bit 8
   TB8 .EQU 0x98+3 ;Transmit Bit 8
   REN .EQU 0x98+4 ;Receive Enable
   SM2 .EQU 0x98+5 ;Serial Mode 2
   SM1 .EQU 0x98+6 ;Serial Mode 1
   SM0 .EQU 0x98+7 ;(WR)Serial Mode 0
   FE  .EQU 0x98+7 ;(RD)Framing Error
SBUF .EQU 0x99
IP2 .EQU 0x9A
PIO .EQU 0x9B
ADCRL .EQU 0x9C
ADCRH .EQU 0x9D
P3M1 .EQU 0x9E
P3M2 .EQU 0x9F
P2 .EQU 0xA0
   P20 .EQU 0xA0+0 ;Port 2 Bit 0
   P21 .EQU 0xA0+1 ;Port 2 Bit 1
   P22 .EQU 0xA0+2 ;Port 2 Bit 2
   P23 .EQU 0xA0+3 ;Port 2 Bit 3
   P24 .EQU 0xA0+4 ;Port 2 Bit 4
   P25 .EQU 0xA0+5 ;Port 2 Bit 5
   P26 .EQU 0xA0+6 ;Port 2 Bit 6
   P27 .EQU 0xA0+7 ;Port 2 Bit 7
   P2_0 .EQU 0xA0+0 ;Port 2 Bit 0
   P2_1 .EQU 0xA0+1 ;Port 2 Bit 1
   P2_2 .EQU 0xA0+2 ;Port 2 Bit 2
   P2_3 .EQU 0xA0+3 ;Port 2 Bit 3
   P2_4 .EQU 0xA0+4 ;Port 2 Bit 4
   P2_5 .EQU 0xA0+5 ;Port 2 Bit 5
   P2_6 .EQU 0xA0+6 ;Port 2 Bit 6
   P2_7 .EQU 0xA0+7 ;Port 2 Bit 7
KBI .EQU 0xA1
AUXR1 .EQU 0xA2
CAPCON0 .EQU 0xA3
CAPCON1 .EQU 0xA4
P4 .EQU 0xA5
CCL2 .EQU 0xA6
CCH2 .EQU 0xA7
IE .EQU 0xA8
   EX0  .EQU 0xA8+0 ;Enable External 0
   ET0  .EQU 0xA8+1 ;Enable Timer 0
   EX1  .EQU 0xA8+2 ;Enable External 1
   ET1  .EQU 0xA8+3 ;Enable Timer 1
   ES   .EQU 0xA8+4 ;Enable Serial
   EBO  .EQU 0xA8+5 ;Enable Brown Out Detect
   EBOD .EQU 0xA8+5 ;Enable Brown Out Detect
   EADC .EQU 0xA8+6 ;Enable ADC
   EA   .EQU 0xA8+7 ;Enable All
SADDR .EQU 0xA9
DTCNT .EQU 0xAB
CMP1 .EQU 0xAC
CMP2 .EQU 0xAD
PDTC0 .EQU 0xAE
ADCDLY .EQU 0xAF
P3 .EQU 0xB0
   P30 .EQU 0xB0+0 ;Port 3 Bit 0
   P31 .EQU 0xB0+1 ;Port 3 Bit 1
   P32 .EQU 0xB0+2 ;Port 3 Bit 2
   P33 .EQU 0xB0+3 ;Port 3 Bit 3
   P34 .EQU 0xB0+4 ;Port 3 Bit 4
   P35 .EQU 0xB0+5 ;Port 3 Bit 5
   P36 .EQU 0xB0+6 ;Port 3 Bit 6
   P37 .EQU 0xB0+7 ;Port 3 Bit 7
   P3_0 .EQU 0xB0+0 ;Port 3 Bit 0
   P3_1 .EQU 0xB0+1 ;Port 3 Bit 1
   P3_2 .EQU 0xB0+2 ;Port 3 Bit 2
   P3_3 .EQU 0xB0+3 ;Port 3 Bit 3
   P3_4 .EQU 0xB0+4 ;Port 3 Bit 4
   P3_5 .EQU 0xB0+5 ;Port 3 Bit 5
   P3_6 .EQU 0xB0+6 ;Port 3 Bit 6
   P3_7 .EQU 0xB0+7 ;Port 3 Bit 7
P0M1 .EQU 0xB1
P0M2 .EQU 0xB2
P1M1 .EQU 0xB3
P1M2 .EQU 0xB4
P2M1 .EQU 0xB5
P2M2 .EQU 0xB6
IP0H .EQU 0xB7
IP .EQU 0xB8
IP0 .EQU 0xB8
   PX0  .EQU 0xB8+0 ;Priority External 0
   PT0  .EQU 0xB8+1 ;Priority Timer 0
   PX1  .EQU 0xB8+2 ;Priority External 1
   PT1  .EQU 0xB8+3 ;Priority Timer 1
   PS   .EQU 0xB8+4 ;Priority Serial
   PBO  .EQU 0xB8+5 ;Priority Brown Out Detect
   PBOD .EQU 0xB8+5 ;Priority Brown Out Detect
   PADC .EQU 0xB8+6 ;Priority ADC
SADEN .EQU 0xB9
I2DATA .EQU 0xBC
I2STATUS .EQU 0xBD
I2CLK .EQU 0xBE
I2TIMER .EQU 0xBF
I2CON .EQU 0xC0
   AA    .EQU 0xC0+2 ;Acknowledge Assert
   SI    .EQU 0xC0+3 ;Status Interrupt
   STO   .EQU 0xC0+4 ;Stop
   STA   .EQU 0xC0+5 ;Start
   ENSI  .EQU 0xC0+6 ;Enable Serial Interface
   I2CEN .EQU 0xC0+6 ;Inter-Integrated Circuit Enable
I2ADDR .EQU 0xC1
T3CON .EQU 0xC2
PNP .EQU 0xC3
NVMADDR .EQU 0xC6
TA .EQU 0xC7
T2CON .EQU 0xC8
   CP_RL2 .EQU 0xC8+0 ;Capture Reload
   TR2    .EQU 0xC8+2 ;Timer 2 Run
   TF2    .EQU 0xC8+7 ;Timer 2 Flag
T2MOD .EQU 0xC9
RCAP2L .EQU 0xCA
RCAP2H .EQU 0xCB
TL2 .EQU 0xCC
TH2 .EQU 0xCD
NVMCON .EQU 0xCE
NVMDAT .EQU 0xCF
PSW .EQU 0xD0
   P   .EQU 0xD0+0 ;Parity
   F1  .EQU 0xD0+1 ;Flag 1
   OV  .EQU 0xD0+2 ;Overflow
   RS0 .EQU 0xD0+3 ;Register Select 0
   RS1 .EQU 0xD0+4 ;Register Select 1
   F0  .EQU 0xD0+5 ;Flag 0
   AC  .EQU 0xD0+6 ;Auxiliary Carry
   CY  .EQU 0xD0+7 ;Carry
PWMPH .EQU 0xD1
PWM0H .EQU 0xD2
EIE2 .EQU 0xD4
PWM2H .EQU 0xD5
PWMCON3 .EQU 0xD7
WDCON .EQU 0xD8
   WDCLR .EQU 0xD8+0 ;Watchdog Clear
   EWRST .EQU 0xD8+1 ;Enable Watchdog Reset
   WTRF  .EQU 0xD8+2 ;Watchdog Timer Reset Flag
   WDIF  .EQU 0xD8+3 ;Watchdog Interrupt Flag
   WD0   .EQU 0xD8+4 ;Watchdog Timeout 0
   WD1   .EQU 0xD8+5 ;Watchdog Timeout 1
   WDRUN .EQU 0xD8+7 ;Watchdog Run
PWMPL .EQU 0xD9
PWM0L .EQU 0xDA
PWMCON1 .EQU 0xDC
PWM2L .EQU 0xDD
PWMB .EQU 0xDF
ACC .EQU 0xE0
   ACC0 .EQU 0xE0+0 ;Accumulator Bit 0
   ACC1 .EQU 0xE0+1 ;Accumulator Bit 1
   ACC2 .EQU 0xE0+2 ;Accumulator Bit 2
   ACC3 .EQU 0xE0+3 ;Accumulator Bit 3
   ACC4 .EQU 0xE0+4 ;Accumulator Bit 4
   ACC5 .EQU 0xE0+5 ;Accumulator Bit 5
   ACC6 .EQU 0xE0+6 ;Accumulator Bit 6
   ACC7 .EQU 0xE0+7 ;Accumulator Bit 7
   ACC_0 .EQU 0xE0+0 ;Accumulator Bit 0
   ACC_1 .EQU 0xE0+1 ;Accumulator Bit 1
   ACC_2 .EQU 0xE0+2 ;Accumulator Bit 2
   ACC_3 .EQU 0xE0+3 ;Accumulator Bit 3
   ACC_4 .EQU 0xE0+4 ;Accumulator Bit 4
   ACC_5 .EQU 0xE0+5 ;Accumulator Bit 5
   ACC_6 .EQU 0xE0+6 ;Accumulator Bit 6
   ACC_7 .EQU 0xE0+7 ;Accumulator Bit 7
ADCCON .EQU 0xE1
ADCH .EQU 0xE2
ADCCON1 .EQU 0xE3
CCL0 .EQU 0xE4
CCH0 .EQU 0xE5
CCL1 .EQU 0xE6
CCH1 .EQU 0xE7
EIE1 .EQU 0xE8
   EI2C  .EQU 0xE8+0 ;Enable Inter-Integrated Circuit
   EKB   .EQU 0xE8+1 ;Enable Keyboard
   ECI   .EQU 0xE8+2 ;Enable Comparator Interrupt
   EWDI  .EQU 0xE8+4 ;Enable Watchdog Interrupt
   EBRK  .EQU 0xE8+5 ;Enable Brake Interrupt
   EPWM  .EQU 0xE8+6 ;Enable Pulse Width Modulator
   ECPTF .EQU 0xE8+7 ;Enable Capture Flag
PORTS .EQU 0xEC
PME .EQU 0xED
PMD .EQU 0xEE
IP2H .EQU 0xEF
B .EQU 0xF0
   B0 .EQU 0xF0+0 ;B Bit 0
   B1 .EQU 0xF0+1 ;B Bit 1
   B2 .EQU 0xF0+2 ;B Bit 2
   B3 .EQU 0xF0+3 ;B Bit 3
   B4 .EQU 0xF0+4 ;B Bit 4
   B5 .EQU 0xF0+5 ;B Bit 5
   B6 .EQU 0xF0+6 ;B Bit 6
   B7 .EQU 0xF0+7 ;B Bit 7
   B_0 .EQU 0xF0+0 ;B Bit 0
   B_1 .EQU 0xF0+1 ;B Bit 1
   B_2 .EQU 0xF0+2 ;B Bit 2
   B_3 .EQU 0xF0+3 ;B Bit 3
   B_4 .EQU 0xF0+4 ;B Bit 4
   B_5 .EQU 0xF0+5 ;B Bit 5
   B_6 .EQU 0xF0+6 ;B Bit 6
   B_7 .EQU 0xF0+7 ;B Bit 7
SPCR .EQU 0xF3
SPSR .EQU 0xF4
SPDR .EQU 0xF5
PADIDS .EQU 0xF6
IP1H .EQU 0xF7
IP1 .EQU 0xF8
   PI2   .EQU 0xF8+0 ;Priority I2C
   PI2C  .EQU 0xF8+0 ;Priority Inter-Integrated Circuit
   PKB   .EQU 0xF8+1 ;Priority Keyboard
   PCI   .EQU 0xF8+2 ;Priority Comparator Interrupt
   PWDI  .EQU 0xF8+4 ;Priority Watchdog Interrupt
   PBRK  .EQU 0xF8+5 ;Priority Brake Interrupt
   PPWM  .EQU 0xF8+6 ;Priority Pulse Width Modulator
   PCAP  .EQU 0xF8+7 ;Priority Input Capture
P4M1 .EQU 0xFA
P4M2 .EQU 0xFB
PWMCON4 .EQU 0xFC
PWM6L .EQU 0xFD
PWM6H .EQU 0xFE
AUXR2 .EQU 0xFF

;.endif